-------------------------------------------------------------------------------------
---------------------------Version 0.8.8 bugfix version 1----------------------------
-------------------------------------------------------------------------------------
------------------------Created by Kopalov and Henny Smafter-------------------------
-------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------
------------------------------------ MOD OPTIONS ------------------------------------
-------------------------------------------------------------------------------------
----------------------------KEYS(See key reference below)----------------------------

local controlkey =  17		-- Control key to use with all other mod keys.
local allowmodkey = 96		-- Key to switch mod ON/OFF.
local mkcustomkey = 97		-- Key to create a custom safehouse.
local mkblipsoff = 103		-- Key to disable all blips.
local mkblipson = 105			-- Key to enable and reload all blips.
local accept_key = 69			-- Key to enter houses/wardrobes and spawning on game start.

-------------------------------------VARIABLES---------------------------------------

local blipsize = 0.7			-- Blip size. Increase or decrease for your taste. Default is 0.7
local spawnhour = 6			-- Clock hour at which you will be spawned in on game load.
local spawnminute = 0			-- Clock minute at which you will be spawned in on game load.
local sleeptimer = 5			-- How many hours does time advance when you save your game.
enablecontroller = true		-- Set to true if you want to use XBox or PS controller.
local waittime = 2750			-- Camera fade-out duration on teleport. Increase if you see textures loading in.
local did_frank_move = false	-- Set to true if Franklin is now living in big house, set to false if in his aunt's house.

--local enable_debug = true
-------------------------------------------------------------------------------------
----------------------------------- KEY REFERENCE -----------------------------------
-------------------------------------------------------------------------------------
--Full list can be found here: http://help.adobe.com/en_US/AS2LCR/Flash_10.0/help.html?content=00000520.html

--	Space = 32            D4 = 52       O = 79             NumPad4 = 100         F9 = 120
--  PageUp = 33           D5 = 53       P = 80             NumPad5 = 101         F10 = 121
--	Next = 34             D6 = 54       Q = 81             NumPad6 = 102         F11 = 122
--  End = 35              D7 = 55       R = 82             NumPad7 = 103         F12 = 123
--	Home = 36             D8 = 56       S = 83             NumPad8 = 104         F13 = 124
--  Left = 37             D9 = 57       T = 84             NumPad9 = 105         F14 = 125
--	Up = 38               A = 65        U = 85             Multiply = 106        F15 = 126
--  Right = 39            B = 66        V = 86             Add = 107             F16 = 127
--	Down = 40             C = 67        W = 87             Separator = 108       F17 = 128
--  Select = 41           D = 68        X = 88             Subtract = 109        F18 = 129
--  print = 42            E = 69        Y = 89             Decimal = 110         F19 = 130
--	Execute = 43          F = 70        Z = 90             Divide = 111          F20 = 131
--  printScreen = 44      G = 71        LWin = 91          F1 = 112              F21 = 132
--	Insert = 45           H = 72        RWin = 92          F2 = 113              F22 = 133
--  Delete = 46           I = 73        Apps = 93          F3 = 114              F23 = 134
--	Help = 47             J = 74        Sleep = 95         F4 = 115              F24 = 135
--  D0 = 48               K = 75        NumPad0 = 96       F5 = 116				 Ctrl = 17
--	D1 = 49               L = 76        NumPad1 = 97       F6 = 117				 Backspace = 8
--  D2 = 50               M = 77        NumPad2 = 98       F7 = 118              Shift = 16
--	D3 = 51               N = 78        NumPad3 = 99       F8 = 119

-------------------------------------------------------------------------------------
----------------------------- CONTROLLER KEY REFERENCE ------------------------------
-------------------------------------------------------------------------------------

-- Use in code 'CONTROLS.IS_CONTROL_PRESSED(2,X)' without ''.
-- Replace X with one of the numbers below, most have multiple numbers you can try.
-- Thanks goes out to H1Vltg3 who came up with these codes.

-- A    - 73 - 70 - 21 - 18
-- X    - 99 - 22
-- Y    - 75 - 56 - 53 - 49 - 23
-- B    - 80 - 45
--
-- L3   - 86 - 28
-- R3   - 79 - 93 - 50 - 29 - 26

-- LB   - 68 - 89 - 38 - 37
-- RB   - 69 - 76 - 90 - 55 - 44
-- LT   - 77 - 72 - 88 - 91 - 25 - 15 - 10
-- RT   - 78 - 71 - 87 - 92 - 46 - 24 - 14 - 11

-- DPUP - 42 - 27
-- DPDN - 48 - 43 - 20 - 19
-- DPLT - 85 - 58 - 52 - 47
-- DPRT - 74 - 54 - 51

-- RSRT - 66 - 13 - 6
-- RSLT - 5
-- RSUP - 3
-- RSDN - 67 - 12 - 4 - 2

-- LSRT - 64 - 59 - 35 - 30 - 9 - 1
-- LSLT - 63 - 34
-- LSUP - 61 - 40 - 32
-- LSDN - 60 - 41 - 39 - 33 - 31 - 8
--
-- CTRL - 62 - 36

-------------------------------------------------------------------------------------
-------------------------------- KNOWN ISSUES ---------------------------------------
-------------------------------------------------------------------------------------
--Game crash on loading a new game. To fix, disable mod before loading and enable afterwards.
--Mission blips disappear. To fix, disable mod blips, then enable after other blips appear.
--Mod is not working properly when replacing character model with NPC model. Currently no fix for this.
--Some objects from houses are missing (for example, Michael's bed). Happens because of MP interiors loading. No fix for this.
-------------------------------------------------------------------------------------
-------------------------------- CHANGELOG ------------------------------------------
-------------------------------------------------------------------------------------
---------------------------------- 0.8.8 --------------------------------------------
--Four new interiors added (Movie Director's cabinet, High-End and Mid-End Apartments from GTA Online, 1 Custom interior).
--Wardrobes added to all houses and hotel rooms.
--A new hotel added (Yellow Jack Inn).
--Mod can now work without Map Editor. All custom interiors will automatically get replaced with default ones if ME is not installed.
--Mod is now compatible with Single Player Apartment (SPA) mod. If you have SPA installed, SPA will handle spawn on game start.
--Save mechanics reworked for compatibility with SPA mod (now you can decide if you want to set this house as your spawn point or not).
--Map blips for entrance, save spot and wardrobe added to interiors.
--Hotel and rent prices re-evaluated.
--All hotel and house interiors are re-assigned. Now all interiors are used.
--GUI menu now auto-hides when walking away from savehouse front door, wardrobe or bed.
--Health restores when saving game inside house.
--Most interiors can now be used for custom savehouses.
---------------------------------- 0.8.7 --------------------------------------------
--Three new custom-created interiors added! Two are trailer interiors.
--Added option to create a save spot (a.k.a "bed") to custom savehouse menu. Use it to make any user-built house your home.
--Spawning on game start now takes place inside a loading area after loading the custom interiors you need to press E to spawn inside your house, not at the doorstep as it used to be before.
--Some house prices are tweaked.
--One night stay option added to hotels.
--Added check for active missions, so mod does not conflict with mission interior use.
--Added explanation to house and interior locals, so you can edit them easier or add custom interiors.
--Added controller controls to turn mod on/off. See controls page in wiki for details.
--Fixed bug with time being reset to 12:00 on realtor office exit.
--Fixed issue with random NPCs spawning in owned interiors (for example, hotel room).
---------------------------------- 0.8.6 --------------------------------------------
--Save folder is now included in the download, so no need to edit mod file and create a new folder.
--Added option to sell custom savehouse. Just go to the doorstep and follow menu instructions.
--"Turn mod off" option is added. Press Ctrl+Num0 to switch On/Off. Keys are rebindable.
--Only one realtor office is left, as others do not match with the office interior and sometimes are buggy.
--Camera fade-out period on spawn lengthened to ensure full texture load. Fade-out duration can be changed in mod options.
--Realtor camera turn angles tweaked, now camera is always (almost) centered on the right house.
--Switch for controller added to mod options (enablecontroller).
--Tweaked camera height and turn angle for interior view when choosing a house.
--Changed top button label in hotel or apartment rent dialog to prevent misunderstanding.
--Added update mechanics for local save files. After this and future updates, you will not have to delete them.
--Added warning message for incomplete installation. If you see it, the mod can't access chosen directory.
--Added "Control" button to prevent conflicts with other mods that use Num keys. Now you have to press Ctrl+Num1 etc (rebindable).
--Fixed "Sell house" crash at realtor's office.
--Fixed bug with weekday not changing when player stayed in hotel for a night.
--Fixed issue with button selection staying below active buttons and thus invisible.
--Fixed bug with custom savespot creation key press while driving. To create a custom savehouse now you need to be on foot!
--Fixed bug with mouse movement switching between menu items.
--Fixed on-screen text alignment. Now it is always centered.
---------------------------------- 0.8.5 --------------------------------------------
--Tested camera_outside for retailers.
--Added camera_outside for houses.
--Added camera_outside for hotels.
--Testing if controller keys can work together with keyboard.
--Added controller keys
--Cleaned up code
--Overall bug fixes
---------------------------------- 0.8.4 --------------------------------------------
--Removed houses to allow more custom savehouse creations.
--Assigned interiors to all remaining houses.
--Retail offices are now fully functioning.
---------------------------------- 0.8.3 --------------------------------------------
--Fine tuned saving and exit mechanics in interiors.
--Added interiors to hotels and apartments.
--Redefined interiors based on the type of house.
--Assigned house coordinates and headings for camera_outside.
--Added basic realtor mechanics.
--Started reworking the GUI.
--Defined locations and interiors for Realtor Offices.
--Added new save spots for some interiors.
--Added wardrobe spots for all interiors.
--Added options for custom savehouse creation.
---------------------------------- 0.8.2 --------------------------------------------
--Restructering of code.
--Cleanup of code.
--Added save mechanics for interiors.
---------------------------------- 0.8.0 --------------------------------------------
--Redefined the house list.
--Added interiors to houses.
---------------------------------- 0.7.8 --------------------------------------------
--Added new houses there are now 93 houses with most of them having parking spaces.
--Changed default keys.
---------------------------------- 0.7.7 --------------------------------------------
--Added User Defined Keys for turning on/off the blips. This can potentially fix problems with missing mission blips.
---------------------------------- 0.7.6 --------------------------------------------
--Improved map blips.
---------------------------------- 0.7.5 --------------------------------------------
--Added directory check.
--Improved spawn-in mechanic (now camera is faded out while you spawn).
--Added more hotels and houses.
--Added automatic hotel and house list update functionality.
--Added new blips for apartments available for rent.
--Improved buttons (GUI will be completely reworked soon).
--Added ability to turn mod on/off.
--Added greeting message to hotels and apartments, which says how many days you have left.
---------------------------------- 0.7.1 --------------------------------------------
--Disabled some debugging tools.

-------------------------------------------------------------------------------------
-- DO NOT EDIT ANYTHING BELOW UNLESS YOU ARE 100% SURE YOU KNOW WHAT YOU ARE DOING --
-------------------------------------------------------------------------------------

local savepath = "".."scripts/addins/savehousefolder/"
shgui_ver_to_display = "0.8.8"
local allowmod = false
local bool_int_check = false

local updatehouses = true
local updatehotels = true
local enablehouse = true
local enablehotels = true
local enablecustom = true

local hupdated = false
local htupdated = false

local sh = {}
local timer = 0
local buttontimer = 0
local price = 0
local textstay = false
local playercash = 0
local currentmodel = 0
local showtext = false

local htable = {}
local httable = {}
local ctable = {}
local htosave = {}
local initialday = 0
local spawnchecker = false

local charactername = "Dummy"

local stopproxtick = false
local tickcooldown = 0
local dirok = true
local intarray = {}
local insidetimer = 0

--Explanation of what numbers in array below mean:
--{interior number (used in h local),door.x,y,z,spawn-in heading,save spot.x,y,z,heading(irrelevant),price,realtor camera.x,y,z,heading,wardrobe.x,y,z,heading}
local interior = {{1,151.4981842041,-1008.05859375,-99.000015258789,336.45590209961, 154.34252929688,-1003.2754516602,-98.999961853027,248.35888671875,50000,
		155.10707092285,-1007.4459228516,-99.333366394043,335.381214141846,151.82553100586,-1001.3131103516,-98.999992370605,89.85001373291},--hotel room
	{2,-1002.6339111328,-477.51965332031,50.027542114258,127.02596282959,-1005.7172851563,-474.99221801758,50.026264190674,0.11998824775219,100000,
		-1010.6307983398,-478.1389465332,51.02668762207,264.74740600586,-1006.4834594727,-473.41024780273,50.027355194092,302.26654052734},--Movie makers cabinet
	{3,-107.83421325684,-8.3598766326904,70.519630432129,97.708541870117, -111.13466644287,-10.718485832214,70.519622802734,14.13726234436,250000,
		-107.83421325684,-8.3598766326904,69.519630432129,147.708541870117,-108.85836791992,-12.107842445374,70.519577026367,57.320114135742},--basic apartment(janitor)
	{4,266.04748535156,-1003.8999023438,-99.004898071289,354.51895141602, 262.90921020508,-1003.1085205078,-99.008575439453,243.61944580078,320000,
		265.70941162109,-999.93121337891,-100.00862121582,5.977752685547,259.72015380859,-1003.942199707,-99.008583068848,165.29786682129},--small house
	{5,1274.1540527344,-1719.6486816406,54.771457672119,15.826478004456, 1276.2813720703,-1714.5952148438,55.081481933594,238.12216186523,340000,
		1275.1337890625,-1715.3297119141,53.771446228027,330.003523826599,1271.8068847656,-1715.0236816406,54.771484375,137.47003173828},--Lester's house
	{6,346.55557250977,-1013.2401733398,-99.196243286133,10.150676727295,349.33096313477,-995.07049560547,-99.196182250977,107.60055541992,450000,
		345.10482788086,-994.36376953125,-99.196258544922,135.84480285645,351.28952026367,-993.49700927734,-99.196243286133,181.52346801758},--Mid class apartment
	{7,-1151.0661621094,-1520.5487060547,10.992719993591,14.21820640564, -1149.865,-1512.601,10.633,14.21820640564,550000,
		-1158.2380371094,-1525.419921875,10.232726669312,93.63565063477,-1143.8873291016,-1515.8082275391,10.632726669312,109.18350982666},--Floyd's house
	{8,-778.5,317.0,223.2,192.2679901123, -759.6259765625,319.87289428711,217.05030822754,253.18368530273,1250000,
		-774.22766113281,319.80389404297,222.25765991211,273.13580322266,-763.26013183594,325.59518432617,217.05038452148,101.15581512451},--Eclypse tower
	{9,1391.1628417969,1131.9582519531,114.33359527588,290.05145263672, 1396.9998779297,1130.5531005859,114.33359527588,172.71952819824,2500000,
		1398.8028564453,1151.7904052734,114.33359527588,180.85752868652,1400.6633300781,1159.7725830078,114.33359527588,156.55033874512},--Madrazo villa
	{10,2157.71,3377.89,45.47,189.85466003418, 2155.2626953125,3379.9167480469,45.474838256836,81.947593688965, 15000,   
		2159.044921875,3381.2854003906,45.463218688965,128.21910095215,2158.5981445313,3380.1977539063,45.466121673584,257.87991333008},--Small Trailer [CSI]
	{11,2199.9487304688,3316.8015136719,46.933620452881,105.63695526123, 2200.78515625,3309.9865722656,46.932884216309,229.53912353516, 35000, 
		2199.3776855469,3314.4904785156,46.7225,24.893392562866,2203.2521972656,3309.3627929688,46.943748474121,38.516464233398},--Large Trailer [CSI]
	{12,-595.342,2086.008,131.412,-565.34686279297,1885.8795166016,123.03510284424,51.142688751221,1000,
		-565.34686279297,1885.8795166016,123.03510284424,51.142688751221,-592.43927001953,2081.3256835938,131.38955688477,358.43142700195}, --Abandoned Mine
	{13,330.94564819336,-1739.3548583984,29.72481918335,121.1615524292, 325.14752197266,-1732.3322753906,29.766353607178,27.345573425293, 220000,
		328.27947998047,-1740.4370117188,29.223560333252,43.624458312988,326.47052001953,-1733.5970458984,29.757610321045,144.27191162109},--Single Story House [CSI]
	{14,-1885.4564208984,-318.50158691406,86.14672088623,71.737762451172, -1885.7130126953,-308.40246582031,86.147583007813,91.245704650879,250000,
		-1885.4564208984,-318.50158691406,86.14672088623,71.737762451172,-1886.1357421875,-311.45623779297,86.148368835449,195.78024291992},--CSI - Crastenburg Luxury Suite (sh12i)
	{15,-24.338340759277,-597.45849609375,80.031105041504,256.68994140625,-37.133399963379,-583.65515136719,78.830291748047,23.558431625366, 1000000, 
		-25.974609375,-578.25537109375,79.230751037598,205.21952819824, -37.372665405273,-587.01342773438,78.830291748047,318.53427124023}, --Lux apartment 2
	--{16,-17.713033676147,-582.01611328125,90.11483001709,84.378204345703,-37.281993865967,-577.89056396484,83.907516479492,52.282314300537,
	--	0,-21.303131103516,-581.83947753906,90.11483001709,88.555328369141,-35.310649871826,-584.31878662109,83.907485961914,247.68955993652},--4 integrity
	--{17,-279.20767211914,-940.33575439453,92.510925292969,172.88970947266,-283.43151855469,-959.89093017578,86.303596496582,136.71524047852,
	--	0,-279.68753051758,-943.19451904297,92.510902404785,190.80548095703,-276.93215942383,-958.07867431641,86.303565979004,17.61277961731},--Alta
	--{18,-776.70465087891,340.30383300781,207.62086486816,126.48251342773,-796.54815673828,337.43472290039,201.41363525391,24.911012649536,
	--	0,-778.95361328125,340.1350402832,207.62088012695,107.99471282959,-792.39678955078,332.1594543457,201.41351318359,303.61172485352},--eclipse
	}

--Explanation of what numbers in array below mean:
--{house number,owner is Mike,Frank,Trevor,Spawn spot for Mike,Frank,Trevor,door.x,y,z,heading on exit,price,1-is owned by someone,interior number,realtor camera.x,y,z,turn angle}
local h = {{1,0,0,0,0,0,0,2200.8125,3318.0876464844,46.945693969727,117.28784179688,49500,0,11,2220.2897949219,3303.6506347656,49.994853973389,23.251819610596},
{2,0,0,0,0,0,0,-952.35943603516,-1077.5021972656,2.6772258281708,28.253629684448,495000,0,4,-982.54486083984,-1053.0965576172,11.007244110107,300.31373596191},
{3,0,0,0,0,0,0,1435.3907470703,3657.1955566406,34.405200958252,108.52089691162,75000,0,5,1442.8699951172,3666.7075195313,39.07922744751,74.44860839844},
{4,0,0,0,0,0,0,-1022.5735473633,-896.88433837891,5.4127054214478,211.37385559082,705000,0,6,-1013.7346191406,-927.47308349609,8.2108774185181,3.1813659667969},
{5,0,0,0,0,0,0,2153.0966796875,3360.3532714844,45.402545928955,24.193983078003,25750,0,10,2167.2490234375,3355.4279785156,47.827484130859,35.351470947266},
{6,0,0,0,0,0,0,-1090.4608154297,-926.64636230469,3.1047008037567,212.1895904541,595000,0,6,-1119.1971435547,-926.77618408203,10.367701530457,304.02557373047},
{7,0,0,0,0,0,0,-1037.1337890625,-1605.3999023438,4.9747915267944,222.46809387207,720000,0,7,-1011.959777832,-1617.4758300781,11.673084259033,29.117679595947},
{8,0,0,0,0,0,0,-1117.0482177734,-1505.7077636719,4.3962988853455,28.927146911621,645000,0,7,-1142.2587890625,-1493.4793701172,10.375087738037,300.02947998047},
{9,0,0,0,0,0,0,-1337.673828125,-1161.4385986328,4.5055766105652,110.89149475098,600000,0,7,-1356.8470458984,-1156.3032226563,10.910389900208,298.54351806641},
{10,0,0,0,0,0,0,1830.8414306641,3737.7463378906,33.961898803711,107.97627258301,125000,0,5,1842.8413085938,3732.7761230469,35.550430297852,39.700386047363},
{11,0,0,0,0,0,0,39.481651306152,-1911.35546875,21.953477859497,83.902862548828,195000,0,4,51.058280944824,-1910.3022460938,24.931642532349,53.96491241455},
{12,0,0,0,0,0,0,333.08139038086,-1741.0046386719,29.73052406311,318.06845092773,215000,0,13,334.98596191406,-1755.3868408203,32.872886657715,6.561699867249},
{13,0,0,0,0,0,0,-437.87545776367,6272.158203125,30.068267822266,145.21424865723,399500,0,6,-469.21697998047,6255.6791992188,33.211269378662,332.70550537109},
{14,0,0,0,0,0,0,401.65399169922,-1849.4552001953,27.31974029541,314.00439453125,295000,0,5,414.39733886719,-1869.1846923828,29.957944869995,9.301488876343},
{15,0,0,0,0,0,0,114.29601287842,-1961.1645507813,21.333984375,196.33277893066,180000,0,5,107.65300750732,-1953.1519775391,23.888135910034,287.44509887695},
{16,0,0,0,0,0,0,1289.4512939453,-1710.42578125,55.476684570313,19.81521987915,390000,0,4,1286.1423339844,-1723.3315429688,59.397666931152,349.79141235352},
{17,0,0,0,0,0,0,31.259983062744,6596.8798828125,32.822235107422,41.795986175537,292500,0,4,43.646369934082,6596.3159179688,34.665603637695,43.648971557617},
{18,0,0,0,0,0,0,1379.2691650391,-1515.1256103516,58.435722351074,26.225738525391,435000,0,4,1380.80078125,-1523.7764892578,60.564113616943,354.79281616211},
{19,0,0,0,0,0,0,1336.9313964844,-1578.7204589844,54.444217681885,36.62419128418,365000,0,5,1341.0511474609,-1590.1513671875,57.566982269287,356.97760009766},
{20,0,0,0,0,0,0,1286.6455078125,-1604.4993896484,54.824893951416,197.29341125488,217500,0,4,1229.1462402344,-1625.2846679688,54.932312011719,308.35455322266},
{21,0,0,0,0,0,0,1303.2377929688,-527.39733886719,71.460662841797,342.12057495117,835000,0,15,1312.2270507813,-542.69128417969,74.88809967041,6.8967566490173},
{22,0,0,0,0,0,0,1250.9047851563,-515.43054199219,69.349052429199,79.019554138184,520000,0,4,1258.6536865234,-523.45141601563,71.096855163574,17.956577301025},
{23,0,0,0,0,0,0,1265.7054443359,-457.94311523438,70.517112731934,105.58794403076,560000,0,6,1274.6768798828,-447.19140625,72.396186828613,64.85556030273},
{24,0,0,0,0,0,0,1046.1593017578,-498.12170410156,64.280700683594,168.53160095215,715000,0,6,1059.2034912109,-487.37780761719,68.40486907959,212.34072113037},
{25,0,0,0,0,0,0,1056.1395263672,-448.89996337891,66.25749206543,167.23979187012,745000,0,6,1066.0256347656,-464.51315307617,69.774253845215,9.816276550293},
{26,0,0,0,0,0,0,987.54217529297,-432.95361328125,64.048942565918,44.81941986084,645000,0,6,1005.3862304688,-438.20111083984,66.757835388184,30.442924499512},
{27,0,0,0,0,0,0,-407.22625732422,6314.2197265625,28.941368103027,34.67387008667,180000,0,4,-411.52947998047,6344.80078125,32.059349060059,99.69355773926},
{28,0,0,0,0,0,0,1250.7086181641,-621.0498046875,69.572059631348,23.362808227539,650000,0,6,1268.3135986328,-623.73187255859,72.440963745117,30.684715270996},
{29,0,0,0,0,0,0,928.87811279297,-639.72320556641,58.242473602295,143.78103637695,595000,0,4,938.92504882813,-637.19458007813,61.875179290771,48.16928863525},
{30,0,0,0,0,0,0,-105.6686706543,6528.6103515625,30.166921615601,132.45999145508,320000,0,4,-108.82811737061,6542.4047851563,33.009498596191,254.58534240723},
{31,0,0,0,0,0,0,1323.3922119141,-582.90966796875,73.246360778809,157.66499328613,835000,0,15,1337.30859375,-578.50402832031,77.116676330566,58.96182250977},
{32,0,0,0,0,0,0,-902.19519042969,191.52545166016,69.445999145508,282.95678710938,2150000,0,9,-922.11279296875,166.70768737793,77.602066040039,339.69607543945},
{33,0,0,0,0,0,0,-1536.7906494141,130.46942138672,57.371311187744,317.7099609375,8750000,0,9,-1581.5893554688,107.33052062988,69.459327697754,335.9052734375},
{34,0,0,0,0,0,0,-1570.4189453125,22.349193572998,59.553970336914,166.57012939453,2550000,0,8,-1545.9226074219,35.339611053467,70.470069885254,61.34618377686},
{35,0,0,0,0,0,0,-830.36145019531,114.73859405518,56.029754638672,278.4912109375,2800000,0,9,-844.09790039063,87.27579498291,62.84557723999,348.45193481445},
{36,0,0,0,0,0,0,-930.41888427734,19.417263031006,48.527233123779,40.528820037842,3150000,0,9,-911.30297851563,21.754030227661,56.893688201904,52.620849609375},
{37,0,0,0,0,0,0,-599.00384521484,147.72102355957,61.672718048096,0.39206323027611,249500,0,2,-596.01782226563,125.19607543945,76.446083068848,4.3191466331482},
{38,0,0,0,0,0,0,-1961.1409912109,211.72970581055,86.80396270752,108.39630126953,1750000,0,9,-1952.4149169922,230.40991210938,88.695083618164,102.19819641113},
{39,0,0,0,0,0,0,2332.7746582031,2524.2177734375,46.624931335449,111.58954620361,22500,0,11,2338.4650878906,2505.982421875,50.267723083496,24.500936508179},
{40,0,0,0,0,0,0,2354.828125,2541.0717773438,47.719581604004,9.934118270874,27500,0,11,2370.8994140625,2535.2807617188,49.367210388184,23.053974151611},
{41,0,0,0,0,0,0,-947.94464111328,567.81616210938,101.50568389893,163.24044799805,2150000,0,15,-958.55615234375,524.60705566406,102.76731872559,352.61703491211},
{42,0,0,0,0,0,0,-1090.0938720703,548.63439941406,103.63327789307,290.7294921875,2600000,0,15,-1042.19921875,544.30242919922,110.69590759277,17.7724609375},
{43,0,0,0,0,0,0,-476.5334777832,647.46771240234,144.38616943359,205.27212524414,5650000,0,8,-486.56652832031,596.93743896484,155.65869140625,348.2673034668},
{44,0,0,0,0,0,0,-450.91583251953,395.32049560547,104.77823638916,266.94213867188,3500000,0,15,-461.6305847168,352.16348266602,113.45934295654,342.57006835938},
{45,0,0,0,0,0,0,1428.6372070313,6353.4677734375,23.984996795654,272.24426269531,250,0,12,1428.3265380859,6352.6225585938,23.984996795654,336.76306152344},
{46,0,0,0,0,0,0,1725.5705566406,4642.3442382813,43.875499725342,318.39929199219,177500,0,5,1720.1704101563,4626.3037109375,48.293216705322,348.44372558594},
{47,0,0,0,0,0,0,1682.8530273438,4689.79296875,43.066341400146,90.946388244629,145000,0,4,1690.9064941406,4677.2856445313,45.850521087646,25.260593414307},
{48,0,0,0,0,0,0,1406.9267578125,3656.1921386719,34.430500030518,293.51428222656,99950,0,4,1392.4926757813,3673.6584472656,36.405673980713,282.29960632324},
{49,0,0,0,0,0,0,1774.6715087891,3742.9738769531,34.655307769775,286.49743652344,32500,0,11,1762.01171875,3743.365234375,37.35665512085,306.44296264648},
{50,0,0,0,0,0,0,-1996.2935791016,591.45739746094,118.1019744873,65.868087768555,1650000,0,9,-1981.3917236328,566.41638183594,132.85655212402,7.957555770874},
{51,0,0,0,0,0,0,-1135.9958496094,375.89050292969,71.299774169922,160.65594482422,1300000,0,8,-1186.5662841797,354.39883422852,81.616508483887,329.12463378906},
{52,0,0,0,0,0,0,-1192.7956542969,564.13763427734,100.33944702148,3.0153667926788,2150000,0,6,-1195.2664794922,544.51983642578,105.76403808594,362.9387512207},
{53,0,0,0,0,0,0,3688.0642089844,4562.9233398438,25.183048248291,95.412635803223,33750,0,5,3697.4604492188,4554.033203125,28.136932373047,11.130897521973},
{54,0,0,0,0,0,0,414.77157592773,-217.55018615723,59.910449981689,161.59375,1050000,0,8,531.85412597656,-192.36167907715,88.482429504395,42.43137359619},
{55,0,0,0,0,0,0,484.40582275391,212.75379943848,108.30947113037,71.241493225098,425000,0,3,559.58209228516,222.09951782227,117.982421875,58.36524963379},
{56,0,0,0,0,0,0,178.97630310059,44.399505615234,87.821884155273,17.04497718811,220000,0,1,164.09629821777,40.882709503174,91.315734863281,325.35260009766},
{57,0,0,0,0,0,0,97.64567565918,-256.23526000977,47.68920135498,161.24147033691,160000,0,3,90.301750183105,-241.06378173828,60.916416168213,275.65760803223},
{58,0,0,0,0,0,0,-229.40692138672,6445.3403320313,31.197460174561,314.38879394531,435000,0,6,-199.52262878418,6453.9936523438,35.518356323242,55.23824310303},
{59,0,0,0,0,0,0,-302.22720336914,6326.9931640625,32.88744354248,215.98263549805,385000,0,6,-301.83740234375,6340.7607421875,35.811233520508,116.21669006348},
{60,0,0,0,0,0,0,-1667.6459960938,-441.37097167969,40.356460571289,56.169540405273,1500000,0,9,-1660.2197265625,-457.98712158203,46.012474060059,4.75666809082},
{61,0,0,0,0,0,0,-3093.8383789063,349.35998535156,7.5411024093628,56.16675567627,1450000,0,7,-3145.8854980469,341.95294189453,17.699901580811,322.10189819336},
{62,0,0,0,0,0,0,-3089.3564453125,221.16107177734,14.118478775024,139.04470825195,1395000,0,7,-3095.3754882813,174.04428100586,23.489078521729,354.65939331055},
{63,0,0,0,0,0,0,-3017.0378417969,746.70697021484,27.780559539795,294.57244873047,2350000,0,7,-2991.150390625,778.96051025391,41.523384094238,62.98583984375},
{64,0,0,0,0,0,0,-2972.560546875,642.36553955078,25.992124557495,308.79751586914,2390000,0,9,-2991.6174316406,621.40576171875,33.043231964111,354.13397216797},
{65,0,0,0,0,0,0,-3037.2260742188,558.72552490234,7.507682800293,84.631408691406,260000,0,7,-3071.220703125,554.86285400391,9.4456663131714,317.54251098633},
{66,0,0,0,0,0,0,-3251.2573242188,1027.2862548828,11.757696151733,88.824409484863,690000,0,7,-3283.3757324219,1012.1139526367,19.645685195923,345.12976074219},
{67,0,0,0,0,0,0,3807.7375488281,4478.5161132813,6.365355014801,20.254426956177,37250,0,4,3802.3447265625,4460.9677734375,11.028670310974,342.20892333984},
{68,0,0,0,0,0,0,-213.61064147949,6396.1733398438,33.085037231445,214.94200134277,305000,0,4,-225.57752990723,6400.5869140625,35.851123809814,296.76879882813},
{69,0,0,0,0,0,0,3725.3442382813,4525.7026367188,22.470499038696,344.69345092773,22500,0,4,3739.6525878906,4549.931640625,26.744304656982,64.23803710938},
-----------------------Apartments from Online------------------------------
--{70, 0,0,0, 0,0,0,-59.124889373779,-616.55456542969,37.356777191162,70.603446960449,476000,0,16,-104.79106903076,-672.34197998047,80.065155029297,336.14379882813}, ---- 4 integr
--{71, 0,0,0, 0,0,0,-255.05390930176,-943.32885742188,31.219989776611,291.94427490234,223000,0,17,-163.04840087891,-911.76275634766,91.470001220703,108.10042572021},
--{72, 0,0,0, 0,0,0,-771.79888916016,351.59423828125,87.998191833496,183.43702697754,500000,0,18,-937.43078613281,249.08908081055,185.41400146484,296.03353881836}, ---- eclipse
}

local htdescr = {{1,"Name","r type","shortstay period","longstay period"},
	{2,"Pipeline Inn","room",2,5},
	{3,"Crown Jewels Motel","room",2,4},
	{4,"Vespucci Beach Rent","apartment",7,30},
	{5,"Vespucci Hotel","room",2,5},
	{6,"Venetian Hotel","room",2,4},
	{7,"Vespucci Beach Rent","apartment",7,30},
	{8,"Vespucci Beach Rent","apartment",7,30},
	{9,"The Viceroy Hotels and Resorts","room",2,5},
	{10,"Little Seoul Sunshine Apartments","apartment",7,30},
	{11,"Crastenburg Hotels & Resorts","room",2,4},
	{12,"Opium Nights Hotel","room",2,5},
	{13,"Casa Cristina","apartment",7,30},
	{14,"Motel","room",3,7},
	{15,"Motel","room",2,5},
	{16,"Von Crastenburg Hotel","room",1,3},
	{17,"Apartment","apartment",7,30},
	{18,"Callisto Apartments","apartment",7,30},
	{19,"Vinewood Gardens Hotel","room",2,5},
	{20,"Centry Manor Hotel","room",2,5},
	{21,"Elgin House Hotel","room",2,5},
	{22,"Motel","room",3,7},
	{23,"Alesandro Hotel","room",2,4},
	{24,"Elkridge Hotel","room",2,5},
	{25,"Banner Hotel & Spa","room",2,5},
	{26,"Motel Wisdahl","room",3,5},
	{27,"Templar Hotels","room",2,4},
	{28,"Hedera Apartment Rent","apartment",7,30},
	{29,"Perrera Beach Motel","room",2,5},
	{30,"Crastenburg Hotels & Resorts","room",2,5},
	{31,"Banner Hotel & Spa","room",2,5},
	{32,"Crastenburg Hotel","room",2,4},
	{33,"Rockford Dorset","room",2,5},
	{34,"The Pink Cage Motel","room",2,5},
	{35,"Apartment Rent","apartment",7,30},
	{36,"Apartment Rent","apartment",7,30},
	{37,"Apartment Rent","apartment",7,30},
	{38,"Hotel","room",2,5},
	{39,"Centry Manor Hotel","house",5,10},
	{40,"The Richman Hotel","room",2,5},
	{41,"Marlowe Vineyard","room",2,4},
	{42,"Dream View Motel","room",3,5},
	{43,"The Motor Hotel","room",2,5},
	{44,"Yellow Jack Inn","room",2,5}
	}
	
local ht = {{0,0},
	{2, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -2194.308, -388.276, 13.470,16.740756988525, 550, 1,-2196.001953125,-421.03961181641,17.475967407227,9.6356735229492,1}, --Pipeline Inn - c
	{3, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -1308.911, -931.208, 13.359,16.740756988525, 70, 1,-1304.2725830078,-921.53576660156,16.785820007324,160.0531463623,1}, --Crown Jewels Motel
	{4, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -988.833, -1575.737, 5.231,16.740756988525, 50, 4,-915.42846679688,-1580.7216796875,17.769908905029,72.668663024902,2}, --4 rent vb
	{5, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -1182.967, -1556.823, 5.038,16.740756988525, 80, 3,-1184.5726318359,-1572.12890625,14.176626205444,345.8005065918,2},
	{6, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -1342.782, -1076.393, 6.939,16.740756988525, 1550, 2,-1362.3631591797,-1127.0716552734,21.392923355103,350.96008300781,1}, -- Venetian
	{7, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -1014.465, -1514.411, 6.517,16.740756988525, 80, 3,-958.72351074219,-1502.2630615234,12.304236412048,96.140251159668,2},
	{8, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -969.335, -1431.057, 7.764,16.740756988525, 80, 3,-900.21649169922,-1357.7850341797,19.593948364258,151.31893920898,2},
	{9, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -822.091, -1223.600, 7.365,16.740756988525, 1200, 2,-689.46734619141,-1201.1041259766,37.534427642822,97.944999694824,1}, --The Viceroy Hotels and resorts
	{10, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -728.485, -880.107, 22.711,16.740756988525, 120, 4,-743.16650390625,-843.03564453125,34.363357543945,212.66691589355,2}, --lit seoul sunshine apartments
	{11, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -875.019, -2179.978, 9.809,16.740756988525, 1800, 14,-997.28668212891,-2156.5856933594,67.879608154297,268.49234008789,1}, --Crastenburg Hot&resorts (airop 1)
	{12, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -737.743, -2274.540, 13.437,16.740756988525, 1500, 14,-860.78961181641,-2351.5788574219,56.248416900635,298.93350219727,1}, --Opium nights hotel 2
	{13, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -69.260, -1526.779, 34.235,16.740756988525, 40, 4,-113.28723144531,-1517.9987792969,41.444793701172,261.82897949219}, --casa cristina (near frank 4)
	{14, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, 372.191, -1791.460, 29.095,16.740756988525, 170, 1,355.08563232422,-1799.9127197266,32.397724151611,260.630859375,1}, --motel 4 (near groove)
	{15, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, 561.689, -1774.355, 33.443,16.740756988525, 285, 1,589.37078857422,-1753.7926025391,34.5348777771,102.40978240967,1}, --motel 3
	{16, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, 435.71450805664,215.06147766113,103.16605377197,337.65612792969, 2500, 14,336.17276000977,132.87686157227,159.00914001465,302.2887878418,1}, --Von Crastenburg 39
	{17, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, 106.98572540283,54.696445465088,77.769584655762,247.14981079102, 95, 3,69.512367248535,31.125217437744,83.412300109863,295.00482177734,2},--47 apt vw bld
	{18, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, 391.36395263672,3.2578566074371,91.93132019043,63.671298980713, 150, 3,354.37658691406,74.447540283203,135.36656188965,213.33442687988,2},--49 apt Callisto Apartments
	{19, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, 328.91983032227,-68.89729309082,73.037803649902,168.40313720703, 1200, 2,229.80067443848,-127.62762451172,138.53036499023,306.85464477539,1},--58 hot Vinewood Gardens
	{20, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, 17.840244293213,318.94683837891,110.91898345947,91.281471252441, 250, 1,-4.4611105918884,369.22543334961,127.11449432373,194.71318054199,1},--65 hot Centry Manor
	{21, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -72.256217956543,142.14944458008,81.495307922363,77.494720458984, 1280, 2,-123.45003509521,161.33447265625,116.46212768555,261.66851806641,1},--61 hot Elgin House
	{22, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, 66.323944091797,-255.91584777832,52.353881835938,123.30829620361, 285, 1,63.001670837402,-229.06024169922,53.588199615479,199.99621582031,1},--73 Motel 3
	{23, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, 307.70330810547,-727.93682861328,29.316793441772,241.75, 1000, 1,357.3076171875,-667.71496582031,70.734985351563,124.97924804688,1},--86 hot Alesandro Hotel 3
	{24, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, 286.54522705078,-937.22918701172,29.467842102051,144.39189147949, 1400, 1,246.4772644043,-956.82666015625,29.302433013916,296.2008972168,1},--93 Elkridge Hotel 2 c94
	{25, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -273.943359375,-883.806640625,31.241750717163,214.62785339355, 3500, 14,-232.29626464844,-1052.3269042969,27.266744613647,99.174385070801,1},--106 Banner Hotel & Spa 2 c107
	{26, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, 57.467880249023,-1004.7907104492,29.357431411743,359.03179931641, 400, 2,41.411602020264,-969.98541259766,29.407648086548,205.88945007324,1},--110 Motel Wisdahl 2 c111
	{27, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, 288.04669189453,-1094.8298339844,29.419662475586,91.308853149414, 1400, 2,323.7985534668,-1047.5621337891,29.263759613037,134.97959899902,1},--114 Templar Hotels 2 c115
	{28, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -1356.611328125,-791.16937255859,20.242179870605,310.51248168945, 80, 4,-1377.1624755859,-847.82238769531,29.43395614624,335.50442504883,2},--143 app rent Hedera c144
	{29, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -1454.5185546875,-656.00653076172,33.381237030029,45.131774902344, 500, 1,-1505.3262939453,-704.96038818359,27.379346847534,336.83966064453,1},--147 Perrera Beach Motel c148
	{30, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -1545.7017822266,-530.62066650391,36.148220062256,33.43384552002, 5550, 14,-1594.7696533203,-512.64611816406,35.388687133789,252.15191650391,1},--151 Crastenburg Hot&Res c152
	{31, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -1660.6646728516,-533.94842529297,36.023990631104,138.85432434082, 1540, 2,-1626.3287353516,-615.32916259766,32.421375274658,15.869771003723,1},--160 banner hotel & spa 3 c161
	{32, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -1857.1146240234,-348.12091064453,49.837738037109,148.86190795898, 5280, 14,-1873.3569335938,-439.27850341797,46.367931365967,348.59582519531,1},--166 Crastenburg Hot 1 c167
	{33, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -570.39379882813,-395.46960449219,35.037891387939,357.26895141602, 200, 1,-590.08898925781,-377.14315795898,34.846225738525,229.64892578125,1},--185 h? Rockford Dorset c186
	{34, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, 340.90374755859,-214.79853820801,58.019241333008,103.72160339355, 300, 1,275.61227416992,-240.42242431641,54.048809051514,285.8727722168,1},--79 Motel 3 The Pink Cage c80
	{35, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -904.55102539063,588.05395507813,101.19079589844,124.93965911865, 85, 4,-907.19555664063,547.23931884766,103.9298324585,353.30892944336,2},--179 h 9 vw hills c180
	{36, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -385.11584472656,159.71208190918,73.733001708984,150.53001403809, 90, 3,-414.32000732422,102.24530029297,77.248886108398,357.71038818359,2},--191 h rent 8 c192
	{37, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -336.16714477539,30.917057037354,47.858982086182,88.831214904785, 120, 4,-399.84027099609,33.926322937012,48.275852203369,263.1630859375,2},--193 h rent 6 c194
	{38, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -273.9186706543,28.600929260254,54.752494812012,251.64653015137, 180, 3,-245.83570861816,29.881273269653,56.653141021729,90.314331054688,2},--195 h vvw 3 c 196
	{39, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -34.174911499023,347.9462890625,113.99765777588,167.380859375, 180, 4,-35.78832244873,337.41912841797,113.91797637939,350.55169677734,2},--197 h 2 Centry Manor c198
	{40, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -1273.7852783203,315.96365356445,65.511772155762,149.59870910645, 8250, 14,-1245.1553955078,247.02830505371,64.278106689453,59.28657913208,1},--199 h1 The Richman Hotel c200
	{41, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -1886.5815429688,2050.2531738281,140.98083496094,192.25430297852, 180, 4,-1901.1721191406,2015.4498291016,141.05686950684,335.9192199707,2},--211 hrent2 Marlowe Vineyard c212
	{42, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, -107.40759277344,6339.9702148438,35.500743865967,231.78079223633, 380, 1,-78.806663513184,6328.1875,31.490365982056,76.804878234863,1},--213 h3 Dream View Motel c214
	{43, 0,0,0, 0,0,0, 0,0, 0,0, 0,0, 1136.5635986328,2641.6394042969,38.143707275391,27.30855178833, 275, 1,1123.3548583984,2675.5356445313,38.383079528809,224.14576721191,1},--Motor hotel c237
	{44,0,0,0, 0,0,0, 0,0, 0,0, 0,0, 1994.7740478516,3046.1611328125,47.215198516846,54.337783813477, 120,1,1996.7211914063,3084.2788085938,47.078716278076,164.56314086914,1} -- Yellow Jack Inn
	}

local realtors = {{-943.048,-278.801,39.5951}} --Highend Class Dorset Drive}

function sh.unload()
	sh.blip_remove()
	--sh.unload_interiors()
end

function sh.init()
	sh.shGUI = Libs["shGUI"]
	sh.shGUI.hidden = true
	sh.filecheck()
	if dirok then
		if sh.modswitch(3) then
			sh.loadfiles()
			sh.whoisplayer()
			initialday = TIME.GET_CLOCK_DAY_OF_MONTH()
			sh.mapeditor_install_check()
			sh.spa_install_check()
		end
	end
end
local no_mapeditor = false
local spa_is_installed = false
local dialogactive = false
local exittype = 0
local exitdelay = 100
local enterdialog = false
local typetoenter = 0
local insidetick = 0
local loading_limbo = false
local isinside = false
local isatrealtor = false
local e_pressed = false
local enter_pressed = false
local wardrobe_active = false
local hinttoshow = "SAFEHOUSE MOD LOADED"
--house proximity--
local ready_to_enter_h = false
local ready_to_enter_ht = false
local ready_to_enter_c = false

local looking_for_save = false
local looking_for_wardrobe = false
local ward_act = false
local house_to_return_to = {}
local is_text_shown = false
local interiors_loaded = {}

function sh.tick()
	
	if (not bool_int_check) then bool_int_check = true sh.activate_interior() end
	
	local playerdriving = PED.IS_PED_IN_ANY_VEHICLE(PLAYER.PLAYER_PED_ID(), true)
	local playerwanted = PLAYER.GET_PLAYER_WANTED_LEVEL(PLAYER.PLAYER_ID())
	local playerped = PLAYER.GET_PLAYER_PED(PLAYER.PLAYER_PED_ID())
	local currentday = TIME.GET_CLOCK_DAY_OF_MONTH()

	if (timer > 1) then timer = timer - 1 sh.drawhint()
	 end

	if (get_key_pressed(allowmodkey) and get_key_pressed(controlkey) and dirok) or (enablecontroller and (CONTROLS.IS_CONTROL_PRESSED(2,77)) and (CONTROLS.IS_CONTROL_PRESSED(2,78)) and (CONTROLS.IS_CONTROL_PRESSED(2,79)) and dirok) then
		if allowmod then allowmod=false sh.modswitch(2) sh.showhint(200, "Savehouse mod OFF")
		else allowmod=true sh.modswitch(1) sh.showhint(200, "Savehouse mod ON")
		end end

if allowmod then

	if (tickcooldown > 0) then stopproxtick = true tickcooldown = tickcooldown - 1
	else stopproxtick = false
	end
	
	if isinside then PLAYER.SET_PLAYER_WANTED_LEVEL(PLAYER.PLAYER_PED_ID(),0,false) end
	
	if (isinside and (not isatrealtor) ) then sh.checkifinside() end --and (not stopproxtick)

	if isinside and (not isatrealtor) then sh.looksave() sh.look_for_wardrobe() end

	if (insidetick>0) then insidetick=insidetick-1 end

	if isinside and (not isatrealtor) then sh.lookexit() end

	if (not CAM.IS_SCREEN_FADED_OUT()) and spawnchecker then spawnchecker = false sh.checkspawn() end
	
	if loading_limbo and (get_key_pressed(accept_key) or (enablecontroller and CONTROLS.IS_CONTROL_PRESSED(2,70))) then loading_limbo = false sh.spawnplayer() end
	
	if (sh.whoisplayer()~=currentmodel) then currentmodel = sh.whoisplayer() sh.blip_remove() sh.blip_add() end

	if (playerwanted==0) and (not playerdriving) then
		if (get_key_pressed(mkcustomkey) and get_key_pressed(controlkey)) or (enablecontroller and (CONTROLS.IS_CONTROL_PRESSED(2,69)) and (CONTROLS.IS_CONTROL_PRESSED(2,99))) then
			sh.custom() end
		if (not stopproxtick) then sh.getproximityh() sh.getproximityht() sh.getproximityc() sh.getproximityr() end end

	if (currentday > initialday) then
		sh.daypassed() --sh.showhint(125,"Day passed by..."..currentday.." - "..initialday)--Debug tool
		initialday = currentday end

	------Reworked house proximity check system------
	
	if ready_to_enter_h then
		if (not is_text_shown) then 
			is_text_shown = true
			sh.showhint(150,"Press E to go inside")
			is_text_shown = false
		end
		if get_key_pressed(accept_key) then ready_to_enter_h = false sh.interior() end
	end
	
	if looking_for_wardrobe then
		if (not is_text_shown) then 
			is_text_shown = true
			sh.showhint(150,"Press E to change outfit")
			is_text_shown = false
		end
		if get_key_pressed(accept_key) then looking_for_wardrobe = false sh.wardrobe() end
	end
	
	if looking_for_save then
		if (not dialogactive) then
			sh.clearbuttons()
			sh.shGUI.addButton("Save and set Spawn",sh.savegame,typetoenter,0,0.33,0.06,0.06)
			sh.shGUI.addButton("Save Game",sh.savegame_no_spawn,typetoenter,0,0.33,0.06,0.06)
			dialogactive = true
		end
	end
	
	------Wardrobe-----------
	if ward_act then 
		local plcoord = ENTITY.GET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(), true)
		if get_key_pressed(accept_key) then ENTITY.FREEZE_ENTITY_POSITION(PLAYER.PLAYER_PED_ID(),false) end
		if 
		((currentmodel==1) and (GAMEPLAY.GET_DISTANCE_BETWEEN_COORDS(plcoord.x, plcoord.y, plcoord.z, -811.65570068359,175.11489868164,76.745376586914, true) > 1.5)) or
		((currentmodel==2) and (did_frank_move) and (GAMEPLAY.GET_DISTANCE_BETWEEN_COORDS(plcoord.x, plcoord.y, plcoord.z,9.1629629135132,528.80310058594,170.63505554199, true) > 1.5)) or
		((currentmodel==2) and (not did_frank_move) and (GAMEPLAY.GET_DISTANCE_BETWEEN_COORDS(plcoord.x, plcoord.y, plcoord.z,-18.159961700439,-1438.759765625,31.101547241211, true) > 1.5)) or
		((currentmodel==3) and (GAMEPLAY.GET_DISTANCE_BETWEEN_COORDS(plcoord.x, plcoord.y, plcoord.z, 1969.0955810547,3814.6833496094,33.428726196289, true) > 1.5)) then
			ward_act = false
			sh.interior()
		end
	end
	
	if (get_key_pressed(mkblipsoff) and get_key_pressed(controlkey)) or  (enablecontroller and (CONTROLS.IS_CONTROL_PRESSED(2,77)) and (CONTROLS.IS_CONTROL_PRESSED(2,78)) and (CONTROLS.IS_CONTROL_PRESSED(2,22))) then	
		sh.blip_remove() end

	if (get_key_pressed(mkblipson) and get_key_pressed(controlkey)) or (enablecontroller and (CONTROLS.IS_CONTROL_PRESSED(2,77)) and (CONTROLS.IS_CONTROL_PRESSED(2,78)) and (CONTROLS.IS_CONTROL_PRESSED(2,70))) then
		sh.blip_remove() sh.blip_add() end
	end
	sh.shGUI.tick()

end

local boolean_for_interior = false
function sh.activate_interior()
	
	print("activate_interior")
	STREAMING.SET_INTERIOR_ACTIVE (108290, true)
	boolean_for_interior = true print("boolean_for_interior = true")
	--if STREAMING.SET_INTERIOR_ACTIVE (mp_interior, true) then it_works = true print("it_works = true") end
	print("end activate_interior")
end

function sh.clearbuttons()
	
	sh.shGUI.buttonCount = 0 
	sh.shGUI.addButton("",sh.choice_inactive_button,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.choice_inactive_button,nil,0,0.0,0.0,0.0)
	sh.shGUI.addButton("",sh.choice_inactive_button,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.choice_inactive_button,nil,0,0.0,0.0,0.0) 
	sh.shGUI.addButton("",sh.choice_inactive_button,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.choice_inactive_button,nil,0,0.0,0.0,0.0) 
	sh.shGUI.addButton("",sh.choice_inactive_button,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.choice_inactive_button,nil,0,0.0,0.0,0.0)
	sh.shGUI.buttonCount = 0 sh.shGUI.hidden = false sh.shGUI.selection = 0
	
end

function sh.wardrobe()
	
	house_to_return_to = ENTITY.GET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(), nil)
	
	CAM.DO_SCREEN_FADE_OUT(250)
	wait(280)
	if (currentmodel==1) then
		ENTITY.SET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(),-811.65570068359,175.11489868164,75.745376586914,true,true,true,true)
		ENTITY.SET_ENTITY_HEADING(PLAYER.PLAYER_PED_ID(),298.0803527832)
	elseif (currentmodel==2) then
		if did_frank_move then 
			ENTITY.SET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(),9.1629629135132,528.80310058594,170.63505554199,true,true,true,true)
			ENTITY.SET_ENTITY_HEADING(PLAYER.PLAYER_PED_ID(),301.041015625)
		else 
			ENTITY.SET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(),-18.159961700439,-1438.759765625,31.101547241211,true,true,true,true)
			ENTITY.SET_ENTITY_HEADING(PLAYER.PLAYER_PED_ID(),71.285522460938)
		end
	elseif (currentmodel==3) then
		ENTITY.SET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(),1969.0955810547,3814.6833496094,33.428726196289,true,true,true,true)
		ENTITY.SET_ENTITY_HEADING(PLAYER.PLAYER_PED_ID(),307.16680908203)
	end
	ENTITY.FREEZE_ENTITY_POSITION(PLAYER.PLAYER_PED_ID(),true)
	wait(waittime)
	CAM.DO_SCREEN_FADE_IN(250)
	
	ward_act = true
	
end

function sh.modswitch(cmd)
	print("modswitch")

	if (cmd==1) then print("option 1")
		local file = io.open(savepath .. "modswitch", "w")
		io.output(file)
		io.write("on" .. "\n")
		io.close(file)
		sh.unload() sh.init()
	elseif (cmd==2) then print("option 2")
		local file = io.open(savepath .. "modswitch", "w")
		io.output(file)
		io.write("off" .. "\n")
		io.close(file)
		sh.unload()
	elseif (cmd==3) then print("option 3")
		local n1 = ""
		for line in io.open(savepath .. "modswitch", "r"):lines() do
			print("msfile line: "..line)
			n1 = line print("N1: "..n1)
		end
		if (n1=="on") then allowmod = true return true --sh.showhint(200, "Mod ON by modswitch")
		else allowmod = false return false --sh.showhint(200, "Mod OFF by modswitch")
		end
		io.close(file)
	end
	print("modswitch end")
end

function sh.spa_install_check()
	print("check for spa")
	local file = io.open("".."scripts/SinglePlayerApartment/save.cfg", "r")
	if file==nil then spa_is_installed = false spawnchecker = true print("SPA save file not detected")
	else io.close(file) spa_is_installed = true spawnchecker = false print("SPA save file detected") end
	print("check for spa end")
end

function sh.mapeditor_install_check()
	print("check for mapeditor")
	local file = io.open("".."scripts/ObjectList.ini", "r")
	if file==nil then 
		print("ObjectList.ini not detected")
		table.remove(interior,10)
		table.insert(interior,10,{10,151.4981842041,-1008.05859375,-99.000015258789,336.45590209961, 154.34252929688,-1003.2754516602,-98.999961853027,248.35888671875,50000,
		155.10707092285,-1007.4459228516,-99.333366394043,335.381214141846,151.82553100586,-1001.3131103516,-98.999992370605,89.85001373291})
		table.remove(interior,11)
		table.insert(interior,11,{11,151.4981842041,-1008.05859375,-99.000015258789,336.45590209961, 154.34252929688,-1003.2754516602,-98.999961853027,248.35888671875,50000,
		155.10707092285,-1007.4459228516,-99.333366394043,335.381214141846,151.82553100586,-1001.3131103516,-98.999992370605,89.85001373291})
		table.remove(interior,13)
		table.insert(interior,13,{13,266.04748535156,-1003.8999023438,-99.004898071289,354.51895141602, 262.90921020508,-1003.1085205078,-99.008575439453,243.61944580078,320000,
		265.70941162109,-999.93121337891,-100.00862121582,5.977752685547,259.72015380859,-1003.942199707,-99.008583068848,165.29786682129})
		table.remove(interior,14)
		table.insert(interior,14,{2,-1002.6339111328,-477.51965332031,50.027542114258,127.02596282959,-1005.7172851563,-474.99221801758,50.026264190674,0.11998824775219,100000,
		-1010.6307983398,-478.1389465332,51.02668762207,264.74740600586,-1006.4834594727,-473.41024780273,50.027355194092,302.26654052734})
		print ("interiors replaced")
		no_mapeditor = true
	else io.close(file)  no_mapeditor = false print("ObjectList.ini detected") end
	print("check for mapeditor end")
end

function sh.enterr()

	sh.shGUI.buttonCount = 0 sh.shGUI.addButton("",sh.choice_inactive_button,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.choice_inactive_button,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.choice_inactive_button,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.choice_inactive_button,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.choice_inactive_button,nil,0,0.0,0.0,0.0) sh.shGUI.addButton("",sh.choice_inactive_button,nil,0,0.0,0.0,0.0)
	sh.shGUI.buttonCount = 0 sh.shGUI.hidden = false sh.shGUI.selection = 0
	sh.shGUI.addButton("Welcome to realtor",sh.choice_inactive_button,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Go inside",sh.realtors,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Cancel",sh.choice_cancel,nil,0,0.33,0.06,0.06)

end

local gametime = 0
local num = 1
--local prevweather = ""
function sh.realtors()

	isatrealtor = true
	rcurrenthouse = {}
	rcurrenttable = {}
	num = 1

	CAM.DO_SCREEN_FADE_OUT(250)
	wait(260)
	gametime = TIME.GET_CLOCK_HOURS()
	--prevweather=ENTITY._GET_PREV_WEATHER_TYPE()
	--TIME.SET_CLOCK_TIME(12,0,0)
	ENTITY.SET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(),117.97893078613,-619.11561474609,205.24681396484,true,true,true,true)
	ENTITY.SET_ENTITY_HEADING(PLAYER.PLAYER_PED_ID(),99.215171813965)
	CAM.SET_GAMEPLAY_CAM_RELATIVE_HEADING(99.215171813965)
	ENTITY.FREEZE_ENTITY_POSITION(PLAYER.PLAYER_PED_ID(),true)
	CAM.SET_FOLLOW_PED_CAM_VIEW_MODE(4)
	ENTITY.SET_ENTITY_VISIBLE(PLAYER.PLAYER_PED_ID(),false)
	wait(waittime+750)
	CAM.DO_SCREEN_FADE_IN(250)

	wait(200)

	sh.clearbuttons()
	sh.shGUI.addButton("Choose category",sh.choice_inactive_button,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Sell my house",sh.rclass,4,0,0.33,0.06,0.06)
	sh.shGUI.addButton("High End",sh.rclass,1,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Middle Class",sh.rclass,2,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Low End",sh.rclass,3,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Exit",sh.rexit,nil,0,0.33,0.06,0.06)
	chosentype = 0

end

local chosentype = 0
local hendtable = {}
local mendtable = {}
local lendtable = {}
local ownedtable = {}
local othertable = {}
local rcurrenthouse = 0
local rcurrenttable = {}
local rcamera_outside = false
local roperationtype = 1

function sh.rclass(tp)

	num = 1
	hendtable = {}
	mendtable = {}
	lendtable = {}
	ownedtable = {}
	othertable = {}
	rcurrenthouse = {}
	rcurrenttable = {}
	chosentype = tp
	local a = 1
	while (a <= #h) do
		local tbl = htable[a]
		if (tonumber(tbl[12])>=750000) and (tonumber(tbl[13])==0) then
			table.insert(hendtable, tbl)
		elseif (tonumber(tbl[12])>=250000) and (tonumber(tbl[12])<750000) and (tonumber(tbl[13])==0) then
			table.insert(mendtable, tbl)
		elseif (tonumber(tbl[12])<250000) and (tonumber(tbl[13])==0) then
			table.insert(lendtable, tbl)
		elseif (tonumber(tbl[13])~=0) and (tonumber(tbl[13])==currentmodel) then
			table.insert(ownedtable, tbl)
		elseif (tonumber(tbl[13])~=0) and (tonumber(tbl[13])~=currentmodel) then
			table.insert(othertable, tbl)
		end
		a = a + 1
	end

	print("he: "..#hendtable.." me: "..#mendtable.." le: "..#lendtable.." ow: "..#ownedtable)

	if (tp==1) then
		if (#hendtable>=1) then
		rcurrenttable = hendtable rcurrenthouse = hendtable[num]
		else sh.showhint(150, "No houses to purchase") end
	elseif (tp==2) then
		if (#mendtable>=1) then
		rcurrenttable = mendtable rcurrenthouse = mendtable[num]
		else sh.showhint(150, "No houses to purchase") end
	elseif (tp==3) then
		if (#lendtable>=1) then
		rcurrenttable = lendtable rcurrenthouse = lendtable[num]
		else sh.showhint(150, "No houses to purchase") end
	elseif (tp==4) then
		if (#ownedtable>=1) then
		rcurrenttable = ownedtable rcurrenthouse = ownedtable[num] print("table set to owned, "..#ownedtable)
		else sh.showhint(150, "You have no houses to sell") end
	end

	roperationtype = tp
	num=1
	if (#rcurrenttable>0) then sh.rcamera_outside()
	else sh.showhint(200, "No houses in chosen category") end

end

function sh.rselectionmove(cmd)

	if (cmd==1) and (num>1) then num = num-1
	elseif (cmd==1) and (num<=1) then sh.showhint(100,"First house in list reached") num=1
	elseif (cmd==2) and (num<#rcurrenttable) then num = num+1
	elseif (cmd==2) and (num>=#rcurrenttable) then sh.showhint(100,"Last house in list reached") num=#rcurrenttable
	end
	rcurrenthouse = rcurrenttable[num]
	sh.rcamera_outside()

end

function sh.rcamera_outside()

	if (num>#rcurrenttable) then num=1 end
	CAM.DO_SCREEN_FADE_OUT(250)
	wait(280)
	ENTITY.SET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(),tonumber(rcurrenthouse[15]),tonumber(rcurrenthouse[16]),tonumber(rcurrenthouse[17]),true,true,true,true)
	print(tonumber(rcurrenthouse[18]))
	CAM.SET_GAMEPLAY_CAM_RELATIVE_HEADING(tonumber(rcurrenthouse[18]))
	ENTITY.SET_ENTITY_HEADING(PLAYER.PLAYER_PED_ID(),tonumber(rcurrenthouse[18]))
	--sh.showhint(600,""..rcurrenthouse[1]..", int: "..rcurrenthouse[14]..", head: "..rcurrenthouse[18]) -- For debug
	CAM.SET_GAMEPLAY_CAM_RELATIVE_PITCH(0, -30)
	CAM.SET_FOLLOW_PED_CAM_VIEW_MODE(4)
	ENTITY.FREEZE_ENTITY_POSITION(PLAYER.PLAYER_PED_ID(),true)
	ENTITY.SET_ENTITY_VISIBLE(PLAYER.PLAYER_PED_ID(),false)
	ENTITY.SET_ENTITY_MAX_SPEED(PLAYER.PLAYER_PED_ID(),0)
	TIME.SET_CLOCK_TIME(15, 0, 0)
	GAMEPLAY.SET_WEATHER_TYPE_NOW_PERSIST("CLEAR")
	sh.rupdatenavmenu()
	wait(waittime)
	CAM.DO_SCREEN_FADE_IN(250)

end

function sh.rupdatenavmenu()

	sh.clearbuttons()
	sh.shGUI.addButton("House "..num.." of "..#rcurrenttable.." USD "..tonumber(rcurrenthouse[12]).."",sh.choice_inactive_button,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Next House",sh.rselectionmove,2,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Choose this house",sh.rgoinside,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Previous House",sh.rselectionmove,1,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Go back",sh.realtors,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Exit",sh.rexit,nil,0,0.33,0.06,0.06)

end

function sh.rgoinside()

	rcurrenthouse = rcurrenttable[num]
	local tp = tonumber(rcurrenthouse[14])
	print("inter in h local:"..tonumber(rcurrenthouse[14]))
	local int = interior[tp]
	print ("set to int "..tonumber(int[1]))
	
	local mp_interior = INTERIOR.GET_INTERIOR_AT_COORDS(tonumber(int[2]), tonumber(int[3]), tonumber(int[4]))
	print("interior set to: "..mp_interior)
	INTERIOR._0x2CA429C029CCF247(mp_interior)
	if boolean_for_interior then STREAMING.SET_INTERIOR_ACTIVE (mp_interior, true)
	else STREAMING.SET_INTERIOR_ACTIVE (mp_interior, 1) end
	--STREAMING.SET_INTERIOR_ACTIVE (mp_interior, 1)
	INTERIOR.DISABLE_INTERIOR (mp_interior, false)
	table.insert(interiors_loaded, mp_interior)

	CAM.DO_SCREEN_FADE_OUT(250)
	wait(500)
	ENTITY.SET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(),tonumber(int[11]),tonumber(int[12]),tonumber(int[13]),true,true,true,true)
	ENTITY.SET_ENTITY_HEADING(PLAYER.PLAYER_PED_ID(),tonumber(int[14]))
	CAM.SET_GAMEPLAY_CAM_RELATIVE_HEADING(tonumber(int[14])+90)
	CAM.SET_FOLLOW_PED_CAM_VIEW_MODE(4)
	ENTITY.FREEZE_ENTITY_POSITION(PLAYER.PLAYER_PED_ID(),true)
	ENTITY.SET_ENTITY_VISIBLE(PLAYER.PLAYER_PED_ID(),false)
	ENTITY.SET_ENTITY_MAX_SPEED(PLAYER.PLAYER_PED_ID(),0)
	wait(250)
	wait (waittime) CAM.DO_SCREEN_FADE_IN(450)
	if (roperationtype<4) then
	sh.clearbuttons()
	sh.shGUI.addButton("USD "..rcurrenthouse[12].."",sh.choice_inactive_button,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Purchase",sh.rbuyconfirm,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Go back",sh.rcamera_outside,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Exit",sh.rexit,nil,0,0.33,0.06,0.06)
	elseif (roperationtype==4) then
	sh.clearbuttons()
	sh.shGUI.addButton("USD "..rcurrenthouse[12].."",sh.choice_inactive_button,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Sell",sh.sellconfirm,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Go back",sh.rcamera_outside,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Exit",sh.rexit,nil,0,0.33,0.06,0.06)
	end

end

function sh.sellconfirm()

	htosave = rcurrenthouse

	sh.clearbuttons()
	sh.shGUI.addButton("USD "..htosave[12].."",sh.choice_inactive_button,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Are you sure",sh.choice_inactive_button,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Yes",sh.housesold,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Cancel",sh.choice_cancel,nil,0,0.33,0.06,0.06)

end

function sh.housesold()

	print("selling house")

	local price = tonumber(htosave[12])
	local mod = (sh.whoisplayer() - 1)
	local statname = "SP"..mod.."_TOTAL_CASH"
	local hash = GAMEPLAY.GET_HASH_KEY(statname)
	local bool, cash = STATS.STAT_GET_INT(hash, 0, -1)
	STATS.STAT_SET_INT(hash, (cash + price), true)
	print("Sold for "..price)
	local counter = (sh.whoisplayer() + 1)
	table.remove(htosave, counter)
	table.insert(htosave, counter, "0")
	table.remove(htosave, (counter+3))
	table.insert(htosave, (counter+3), "0")
	table.remove(htosave, 13)
	table.insert(htosave, 13, "0")
	table.remove(htable, htosave[1])
	table.insert(htable, htosave[1], htosave)
	sh.writetofile()
	sh.showhint(150,"Property sold for $"..price)
	sh.blip_remove()
	sh.blip_add()

	sh.realtors()

	print("house sold")

end

function sh.rbuyconfirm()

	sh.clearbuttons()
	if (not sh.domoneycheck(tonumber(rcurrenthouse[12]))) then
		sh.shGUI.addButton("Price is USD "..rcurrenthouse[12].."",sh.choice_inactive_button,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Not enough money",sh.choice_inactive_button,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Go back",sh.realtors,nil,0,0.33,0.06,0.06)
	elseif (sh.domoneycheck(tonumber(rcurrenthouse[12]))) then
		sh.shGUI.addButton("Buy for USD "..rcurrenthouse[12].."",sh.choice_inactive_button,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Yes",sh.housebought,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Go back",sh.rgoinside,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Exit",sh.rexit,nil,0,0.33,0.06,0.06)
	end

end

function sh.housebought()
	print("buying house")
	local price = tonumber(rcurrenthouse[12])
	local mod = (sh.whoisplayer() - 1)
	local statname = "SP"..mod.."_TOTAL_CASH"
	local hash = GAMEPLAY.GET_HASH_KEY(statname)
	local bool, cash = STATS.STAT_GET_INT(hash, 0, -1)
	STATS.STAT_SET_INT(hash, (cash - price), true)
	print("Purchased for "..price)
	local counter = (sh.whoisplayer() + 1)
	local num = tonumber(rcurrenthouse[1])
	table.remove(rcurrenthouse, counter)
	table.insert(rcurrenthouse, counter, "1")
	table.remove(rcurrenthouse, 13)
	table.insert(rcurrenthouse, 13, currentmodel)
	table.remove(htable, num)
	table.insert(htable, num, rcurrenthouse)
	sh.writetofile()
	sh.showhint(150,"Property bought for $"..price)
	sh.blip_remove()
	sh.blip_add()
	wait(150)

	rcurrenthouse = {}
	rcurrenttable = {}
	sh.realtors()
	print("house bought")
end

local roffice = {}
function sh.rexit()

	chosentype = 0
	sh.shGUI.buttonCount = 0 sh.shGUI.hidden = true
	CAM.DO_SCREEN_FADE_OUT(250)
	wait(500)
	--ENTITY.SET_RANDOM_WEATHER_TYPE() -- More testing needed
	print("saved clock time: "..gametime)
	TIME.SET_CLOCK_TIME(gametime,0,0)
	--GAMEPLAY.SET_WEATHER_TYPE_NOW(prevweather) --More testing needed
	ENTITY.SET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(),tonumber(roffice[1]),tonumber(roffice[2]),tonumber(roffice[3]),true,true,true,true)
	ENTITY.SET_ENTITY_HAS_GRAVITY(PLAYER.PLAYER_PED_ID(),true)
	ENTITY.FREEZE_ENTITY_POSITION(PLAYER.PLAYER_PED_ID(),false)
	ENTITY.SET_ENTITY_VISIBLE(PLAYER.PLAYER_PED_ID(),true)
	CAM.SET_FOLLOW_PED_CAM_VIEW_MODE(1)
	ENTITY.SET_ENTITY_MAX_SPEED(PLAYER.PLAYER_PED_ID(),15000)
	GAMEPLAY.CLEAR_WEATHER_TYPE_PERSIST()
	GAMEPLAY.SET_RANDOM_WEATHER_TYPE()
	wait(250)
	wait (waittime) CAM.DO_SCREEN_FADE_IN(450)

	--sh.unload_interiors()
	rcurrenthouse = {}
	rcurrenttable = {}
	isatrealtor = false
	tickcooldown = 400

end

function sh.exithouse()

	if (typetoenter == 1) then
			CAM.DO_SCREEN_FADE_OUT(250)
			wait(500)
			ENTITY.SET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(),tonumber(htosave[8]), tonumber(htosave[9]), tonumber(htosave[10]),true,true,true,true)
			ENTITY.SET_ENTITY_HEADING(PLAYER.PLAYER_PED_ID(),tonumber(htosave[10]))
			isinside = false
			wait(250)
			wait (waittime) CAM.DO_SCREEN_FADE_IN(450)
		elseif (typetoenter == 2) then
			CAM.DO_SCREEN_FADE_OUT(250)
			wait(500)
			ENTITY.SET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(),tonumber(httosave[14]), tonumber(httosave[15]), tonumber(httosave[16]),true,true,true,true)
			ENTITY.SET_ENTITY_HEADING(PLAYER.PLAYER_PED_ID(),tonumber(httosave[17]))
			isinside = false
			wait(250)
			wait (waittime) CAM.DO_SCREEN_FADE_IN(450)
		elseif (typetoenter == 3) then
			CAM.DO_SCREEN_FADE_OUT(250)
			wait(500)
			ENTITY.SET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(),tonumber(ctosave[8]), tonumber(ctosave[9]), tonumber(ctosave[10]),true,true,true,true)
			ENTITY.SET_ENTITY_HEADING(PLAYER.PLAYER_PED_ID(),tonumber(ctosave[10]))
			isinside = false
			wait(250)
			wait (waittime) CAM.DO_SCREEN_FADE_IN(450)
	end

	sh.blip_remove()
	sh.blip_add()
	--sh.unload_interiors()
	--sh.clearbuttons() 
	sh.shGUI.hidden = true
	isinside = false
	dialogactive = false
	tickcooldown = 200

end

function sh.looksave()

	--print("lookforsave")
	if (sh.shGUI.hidden) then dialogactive = false end
	local plcoord = ENTITY.GET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(), true)
	if (GAMEPLAY.GET_DISTANCE_BETWEEN_COORDS(plcoord.x, plcoord.y, plcoord.z, intarray[6], intarray[7], intarray[8], true) < 1) then
		looking_for_save = true
	else looking_for_save = false sh.clearbuttons() sh.shGUI.hidden = true
	end
	--print("lookforsave end")

end

function sh.look_for_wardrobe()
	
	--print("lookforward")
	--if (sh.shGUI.hidden) then dialogactive = false end
	local plcoord = ENTITY.GET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(), true)
	if (GAMEPLAY.GET_DISTANCE_BETWEEN_COORDS(plcoord.x, plcoord.y, plcoord.z, intarray[15], intarray[16], intarray[17], true) < 1) then
		looking_for_wardrobe = true
	else looking_for_wardrobe = false --sh.clearbuttons() sh.shGUI.hidden = true
	end
	--print("lookforward end")
	
end

function sh.lookexit()

	--print("lookexit")

	local plcoord = ENTITY.GET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(), true)

	if (GAMEPLAY.GET_DISTANCE_BETWEEN_COORDS(plcoord.x, plcoord.y, plcoord.z, intarray[2], intarray[3], intarray[4], true) < 0.5) then--intarray[15]) then
		if (insidetick<=0) then sh.exithouse() end
	end

	--print("lookexit end")

end

--blip 366 - wardrobe

local interblip = {}
local interbliptable = {}
function sh.blip_add_for_interior(array)

	print ("adding inter blips")
	sh.blip_remove()
	sh.blip_add()
	interblip = {}
	interbliptable = {}

	local intblip = {}
		intblip = UI.ADD_BLIP_FOR_COORD(intarray[6],intarray[7],intarray[8])
		UI.SET_BLIP_SPRITE(intblip, 430) -------------------------------------change blip icon
		UI.SET_BLIP_SCALE(intblip, blipsize)
		UI.SET_BLIP_AS_SHORT_RANGE(intblip, true)
		table.insert(interbliptable, (#interbliptable+1), intblip)
	
	local wardblip = {}
		wardblip = UI.ADD_BLIP_FOR_COORD(intarray[15],intarray[16],intarray[17])
		UI.SET_BLIP_SPRITE(wardblip, 366) -------------------------------------change blip icon
		UI.SET_BLIP_SCALE(wardblip, blipsize)
		UI.SET_BLIP_AS_SHORT_RANGE(wardblip, true)
		table.insert(interbliptable, (#interbliptable+1), wardblip)
		
	local exitblip = {}
		exitblip = UI.ADD_BLIP_FOR_COORD(intarray[2],intarray[3],intarray[4])
		UI.SET_BLIP_SPRITE(exitblip,290) -------------------------------------change blip icon
		UI.SET_BLIP_SCALE(exitblip, blipsize)
		UI.SET_BLIP_AS_SHORT_RANGE(exitblip, true)
		table.insert(interbliptable, (#interbliptable+1), exitblip)

	print ("inter blips added: "..#interbliptable)

end

local cnt = 0
function sh.getproximityh()

	local plcoord = ENTITY.GET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(), true)

	if(cnt >= #htable) then cnt = 0 end
	cnt = cnt + 1
	local coord = htable[cnt]

	if (GAMEPLAY.GET_DISTANCE_BETWEEN_COORDS(plcoord.x, plcoord.y, plcoord.z, coord[8], coord[9], coord[10], true) < 2)
		and (tonumber(coord[13])==currentmodel) then
		htosave = htable[cnt] print("table set for htable "..cnt)
		typetoenter = 1
		ready_to_enter_h = true
	else ready_to_enter_h = false
		--stopproxtick = true print("tick stopped")
		--tickcooldown = 200 print("tick cooldown")
		--htosave = htable[cnt] print("table set for htable "..cnt)
		--sh.safehouse() print("safehouse initiated")
	end

end

local cntht = 1
function sh.getproximityht()

	local plcoord = ENTITY.GET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(), true)

	if(cntht >= #httable) then cntht = 1 end
	cntht = cntht + 1

	local coord = httable[cntht]

	--if (GAMEPLAY.GET_DISTANCE_BETWEEN_COORDS(plcoord.x, plcoord.y, plcoord.z, coord[14], coord[15], coord[16], true) < 2) then
	--	httosave = httable[cntht] print("table set for httable "..cntht)
	--	typetoenter = 2
	--	ready_to_enter_ht = true
	--else ready_to_enter_ht = false

	if (GAMEPLAY.GET_DISTANCE_BETWEEN_COORDS(plcoord.x, plcoord.y, plcoord.z, coord[14], coord[15], coord[16], true) < 2) then
		stopproxtick = true print("tick stopped")
		tickcooldown = 400 print("tick cooldown")
		httosave = httable[cntht] print("table set for httable "..cntht)
		sh.hotel() print("hotel initiated")
	end

end

local cntc = 0
function sh.getproximityc()

	local plcoord = ENTITY.GET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(), true)

	if(cntc >= #ctable) then cntc = 0 end
	cntc = cntc + 1

	local coord = ctable[cntc]

	if (GAMEPLAY.GET_DISTANCE_BETWEEN_COORDS(plcoord.x, plcoord.y, plcoord.z, coord[8], coord[9], coord[10], true) < 2)
		and (tonumber(coord[13])==1) then
		stopproxtick = true print("tick stopped")
		tickcooldown = 200 print("tick cooldown")
		ctosave = ctable[cntc] print("table set for ctable "..cntc)
		sh.customsh() print("customsh initiated")
	end

end

local cntr = 0
function sh.getproximityr()

	local plcoord = ENTITY.GET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(), true)

	if(cntr >= #realtors) then cntr = 0 end
	cntr = cntr + 1

	local coord = realtors[cntr]

	if (GAMEPLAY.GET_DISTANCE_BETWEEN_COORDS(plcoord.x, plcoord.y, plcoord.z, coord[1], coord[2], coord[3], true) < 2) then
		stopproxtick = true print("tick stopped")
		tickcooldown = 200 print("tick cooldown")
		roffice = realtors[cntr]
		sh.enterr() print("realtors initiated")
	end

end

local cur_inside_interior = 0
local cntint = 0
function sh.checkifinside()
	
	--print("check if inside")
	local plcoord = ENTITY.GET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(), true)
	local coord = interior[cur_inside_interior]
	--print("setting cur_ins_int to "..cur_inside_interior)

	if (GAMEPLAY.GET_DISTANCE_BETWEEN_COORDS(plcoord.x, plcoord.y, plcoord.z, coord[6], coord[7], coord[8], true) > 30) then
		isinside = false 
		--sh.unload_interiors()
		print("is not inside") end

end


function sh.interior()
	print("interior")
	local array = {}
	sh.clearbuttons() sh.shGUI.hidden = true

	print("typetoenter: "..typetoenter)
	if (typetoenter==1) then array = interior[tonumber(htosave[14])] intarray = array
	elseif (typetoenter==2) then array = interior[tonumber(httosave[19])] intarray = array
	elseif (typetoenter==3) then array = interior[tonumber(ctosave[14])] intarray = array
		end

	local mp_interior = INTERIOR.GET_INTERIOR_AT_COORDS(tonumber(array[2]), tonumber(array[3]), tonumber(array[4]))
	print("interior set to: "..mp_interior)
	INTERIOR._0x2CA429C029CCF247(mp_interior)
	if boolean_for_interior then STREAMING.SET_INTERIOR_ACTIVE (mp_interior, true)
	else STREAMING.SET_INTERIOR_ACTIVE (mp_interior, 1) end
	--STREAMING.SET_INTERIOR_ACTIVE (mp_interior, 1)
	INTERIOR.DISABLE_INTERIOR (mp_interior, false)
	table.insert(interiors_loaded, mp_interior)

	CAM.DO_SCREEN_FADE_OUT(250)
	wait(500)
	ENTITY.SET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(),tonumber(array[2]), tonumber(array[3]), tonumber(array[4]),true,true,true,true)
	ENTITY.SET_ENTITY_HEADING(PLAYER.PLAYER_PED_ID(),tonumber(array[5]))
	cur_inside_interior = tonumber(array[1])
	print("cur_inside_interior set to "..cur_inside_interior)
	GAMEPLAY.CLEAR_AREA_OF_PEDS(tonumber(array[6]), tonumber(array[7]), tonumber(array[8]), 15, true) --Testing needed
	ENTITY.FREEZE_ENTITY_POSITION(PLAYER.PLAYER_PED_ID(),true)
	isinside = true
	wait(250)
	wait (waittime) CAM.DO_SCREEN_FADE_IN(450)
	wait(1200)
	ENTITY.FREEZE_ENTITY_POSITION(PLAYER.PLAYER_PED_ID(),false)

	insidetick = 300
	sh.showhint(150,"Welcome, "..charactername)
	cur_inside_interior = tonumber(array[1])
	dialogactive = false
	sh.blip_add_for_interior(array)

	print("interior end")
end

function sh.safehouse()

	print("safehouse")

	local counter = (currentmodel + 1)
	local owned = false
	

	if (tonumber(htosave[13])==currentmodel) then
		owned = true print("sh set to owned")
		typetoenter = 1
		local a = 100
		
		while (a>0) do
			hinttoshow = "Press E to enter"
			sh.drawhint()--(5,"Press E to Enter")
			if get_key_pressed(69) then --Test. Maybe change to get_key and increase while period
				a = 0
				sh.interior()
			end
			wait(10)
			a = a - 1
		end
		--sh.clearbuttons()
		--sh.shGUI.addButton("Go inside",sh.interior,nil,0,0.33,0.06,0.06)
		--sh.shGUI.addButton("Cancel",sh.choice_cancel,nil,0,0.33,0.06,0.06)
	
	end
	print("end safehouse")
end

function sh.buyconfirm()
	sh.clearbuttons()
	sh.shGUI.addButton("Are you sure",sh.choice_inactive_button,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Yes",sh.housebought,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Cancel",sh.choice_cancel,nil,0,0.33,0.06,0.06)
end

function sh.savegame_no_spawn()
	
	ENTITY.SET_ENTITY_HEALTH(PLAYER.PLAYER_PED_ID(), 200)
	GAMEPLAY.SET_SAVE_MENU_ACTIVE(true)
	wait(1000)
	
end

function sh.savegame(tp)

	ENTITY.SET_ENTITY_HEALTH(PLAYER.PLAYER_PED_ID(), 200)
	local count = (currentmodel + 4)
	if enablehouse then
	local i = 1
	while (i <= #htable) do
		local val = htable[i]
		table.remove(val, count)
		table.insert(val, count, "0")
		table.remove(htable, i)
		table.insert(htable, i, val)
		i = i + 1
		print("SG active. Changing htable field "..i)
	end
	end

	if enablehotels then
	local o = 2
	while (o <= #httable) do
		local val = httable[o]
		table.remove(val, count)
		table.insert(val, count, "0")
		table.remove(httable, o)
		table.insert(httable, o, val)
		o = o + 1
		print("SG active. Changing httable field "..o)
	end
	end

	if enablecustom then
	local p = 1
	while (p <= #ctable) do
		local val = ctable[p]
		table.remove(val, count)
		table.insert(val, count, "0")
		table.remove(ctable, p)
		table.insert(ctable, p, val)
		p = p + 1
		print("SG active. Changing ctable field "..p)
	end
	end

	if (tp == 1) then
		local num = tonumber(htosave[1])
		local savearray = htable[num]
		table.remove(htosave, count)
		table.insert(htosave, count, "1")
		table.remove(htable, num)
		table.insert(htable, num, htosave)
	elseif (tp == 2) then
		local num = tonumber(httosave[1])
		local savearray = httable[num]
		table.remove(httosave, count)
		table.insert(httosave, count, "1")
		table.remove(httable, num)
		table.insert(httable, num, httosave)
	elseif (tp == 3) then
		local num = tonumber(ctosave[1])
		local savearray = ctable[num]
		table.remove(ctosave, count)
		table.insert(ctosave, count, "1")
		table.remove(ctable, num)
		table.insert(ctable, num, ctosave)
	end

	sh.writetofile()
	print("This type "..tp.." place is set as spawn location")

	GAMEPLAY.SET_SAVE_MENU_ACTIVE(true)
	wait(1000)

	if (tp == 1) or (tp==2) then sh.camera_outside() end

	wait(150)
	sh.showhint(150,"This place was set as your spawning spot")
	dialogactive = false
	wait(1500)

end

local ahtdescr = {}
function sh.hotel()

	print("hotel")

	stopproxtick = true print("tick stopped")
	local counter = (currentmodel + 1)
	local owned = false
	local notowned = false
	local num1 = tonumber(httosave[1])
	ahtdescr = htdescr[num1]
	sh.showhint(350,"Welcome to "..ahtdescr[2])

	if (tonumber(httosave[counter])==1) then
	owned = true print("set to owned")
	elseif (tonumber(httosave[counter])==0) then
	notowned = true print("set to not owned")
	end

	if owned then
			print("owned")
			local daysleft = 0
			if (currentmodel==1) then daysleft = tonumber(httosave[8])
			elseif (currentmodel==2) then daysleft = tonumber(httosave[10])
			elseif (currentmodel==3) then daysleft = tonumber(httosave[12]) end
			typetoenter = 2
			sh.clearbuttons()
			sh.shGUI.addButton(""..daysleft.." days left",sh.choice_inactive_button,nil,0,0.33,0.06,0.06)
			sh.shGUI.addButton("Go inside",sh.interior,nil,0,0.33,0.06,0.06)
			sh.shGUI.addButton("Cancel",sh.choice_cancel,nil,0,0.33,0.06,0.06)
	else
		sh.clearbuttons()
		sh.shGUI.addButton("USD "..httosave[18].." for one night",sh.rentnight,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Rent "..ahtdescr[3].." for "..ahtdescr[4].." days",sh.rentshort,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Rent "..ahtdescr[3].." for "..ahtdescr[5].." days",sh.rentlong,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Cancel",sh.choice_cancel,nil,0,0.33,0.06,0.06)
	end

	print("end hotel")

end

function sh.rentnight()
	
	sh.clearbuttons()
	if (not sh.domoneycheck(tonumber(ahtdescr[4]))) then
		sh.shGUI.addButton("Not enough money",sh.choice_inactive_button,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Cancel",sh.choice_cancel,nil,0,0.33,0.06,0.06)
	elseif (sh.domoneycheck(tonumber(ahtdescr[4]))) then
		sh.shGUI.addButton("Are you sure",sh.choice_inactive_button,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Yes",sh.hotelrent,3,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Cancel",sh.choice_cancel,nil,0,0.33,0.06,0.06)
	end
end

function sh.rentshort()
	sh.clearbuttons()
	if (not sh.domoneycheck(tonumber(ahtdescr[4])*tonumber(httosave[18]))) then
		sh.shGUI.addButton("Not enough money",sh.choice_inactive_button,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Cancel",sh.choice_cancel,nil,0,0.33,0.06,0.06)
	elseif (sh.domoneycheck(tonumber(ahtdescr[4])*tonumber(httosave[18]))) then
		sh.shGUI.addButton("Are you sure",sh.choice_inactive_button,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Yes",sh.hotelrent,1,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Cancel",sh.choice_cancel,nil,0,0.33,0.06,0.06)
	end
end

function sh.rentlong()
	sh.clearbuttons()
	if (not sh.domoneycheck(tonumber(ahtdescr[5])*tonumber(httosave[18]))) then
		sh.shGUI.addButton("Not enough money",sh.choice_inactive_button,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Cancel",sh.choice_cancel,nil,0,0.33,0.06,0.06)
	elseif (sh.domoneycheck(tonumber(ahtdescr[5])*tonumber(httosave[18]))) then
		sh.shGUI.addButton("Are you sure",sh.choice_inactive_button,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Yes",sh.hotelrent,2,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Cancel",sh.choice_cancel,nil,0,0.33,0.06,0.06)
	end
end

function sh.hotelrent(tp)

	print("renting room")
	sh.clearbuttons()
	local durofstay = 0
	if (tp==1) then durofstay = tonumber(ahtdescr[4])
	elseif (tp==2) then durofstay = tonumber(ahtdescr[5])
	elseif (tp==3) then durofstay = 1 end

	local rcount = 0
	if (currentmodel == 1) then rcount = 8
	elseif (currentmodel == 2) then rcount = 10
	elseif (currentmodel == 3) then rcount = 12 end

	table.remove(httosave, rcount)
	table.insert(httosave, rcount, durofstay)

	local price = (durofstay*tonumber(httosave[18]))
	local mod = (sh.whoisplayer() - 1)
	local statname = "SP"..mod.."_TOTAL_CASH"
	local hash = GAMEPLAY.GET_HASH_KEY(statname)
	local bool, cash = STATS.STAT_GET_INT(hash, 0, -1)
	STATS.STAT_SET_INT(hash, (cash - price), true)
	print("rented for "..price)

	local num = tonumber(httosave[1])
	local counter = (currentmodel + 1)
	table.remove(httosave, counter)
	table.insert(httosave, counter, "1")
	table.remove(httable, num)
	table.insert(httable, num, httosave)
	sh.writetofile()
	stopproxtick = false
	sh.showhint(150,"Rented for USD "..price)
		sh.blip_remove()
		sh.blip_add()

	print("room rented")

end

function sh.daypassed()
	print("daypassed")
	local i=2
	while (i <= #httable) do
		local val = httable[i]
		local hot = htdescr[i]
		--local counter = (currentmodel + 1)
		local day1 = tonumber(val[8])-1
		if (tonumber(val[2]) == 1) and (day1 > 0) then
			table.remove(val, 8)
			table.insert(val, 8, day1)
		elseif (tonumber(val[2]) == 1) and (day1 <= 0) then
			sh.showhint(300, "Rent time for Michael at "..hot[2].." has ended".."\n".."We hope you enjoyed your stay")
			table.remove(val, 8)
			table.insert(val, 8, "0")
			table.remove(val, 2)
			table.insert(val, 2, "0")
		end

		local day2 = tonumber(val[10])-1
		if (tonumber(val[3]) == 1) and (day2 > 0) then
			table.remove(val, 10)
			table.insert(val, 10, day2)
		elseif (tonumber(val[3]) == 1) and (day2 <= 0) then
			sh.showhint(300, "Rent time for Franklin at "..hot[2].." has ended".."\n".."We hope you enjoyed your stay")
			table.remove(val, 10)
			table.insert(val, 10, "0")
			table.remove(val, 3)
			table.insert(val, 3, "0")
		end

		local day3 = tonumber(val[12])-1
		if (tonumber(val[4]) == 1) and (day3 > 0) then
			table.remove(val, 12)
			table.insert(val, 12, day3)
		elseif (tonumber(val[4]) == 1) and (day3 <= 0) then
			sh.showhint(300, "Rent time for Trevor at "..hot[2].." has ended".."\n".."We hope you enjoyed your stay")
			table.remove(val, 12)
			table.insert(val, 12, "0")
			table.remove(val, 4)
			table.insert(val, 4, "0")
		end
		table.remove(httable, i)
		table.insert(httable, i, val)
		sh.writetofile()
		i = i + 1
	end
		sh.blip_remove()
		sh.blip_add()
	print("daypassed end")
end

local is_savespot = false
function sh.custom()

	is_savespot = false
	sh.clearbuttons()
	sh.shGUI.addButton("Create house here",sh.choice_type_of_custom,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Create save spot here",sh.cspot,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Cancel",sh.choice_cancel,nil,0,0.33,0.06,0.06)

	abc=true
	aa=true
	ba=true
	ca=true
	cba=true

end

function sh.cspot()
	
	is_savespot = true
	sh.clearbuttons()
	sh.shGUI.addButton("Price USD 500000",sh.choice_inactive_button,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Confirm",sh.customcreated,0,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Cancel",sh.choice_cancel,nil,0,0.33,0.06,0.06)
	
end

local abc = true
function sh.choice_type_of_custom()

	abc = true
	sh.clearbuttons()
	if abc then
		sh.shGUI.addButton("Choose House Class",sh.choice_inactive_button,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("High End",sh.choice_interior_of_custom,1,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Middle Class",sh.choice_interior_of_custom,2,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Low End",sh.choice_interior_of_custom,3,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Cancel",sh.choice_cancel,nil,0,0.33,0.06,0.06)
		abc = false
	end

end

local aa = true
local ba = true
local ca = true
local cba = true
function sh.choice_interior_of_custom(tp)

	aa = true
	ba = true
	ca = true
	cba = true

	sh.clearbuttons()

	if cba then
	if (tp==1) and aa then
		sh.shGUI.addButton("Choose House Interior",sh.choice_inactive_button,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Floyds House 550K",sh.customconfirm,7,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Richard Majestic 1000K",sh.customconfirm,15,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Eclypse Tower 1250K",sh.customconfirm,8,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Madrazo Mansion 2500K",sh.customconfirm,9,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Go back",sh.choice_type_of_custom,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Cancel",sh.choice_cancel,nil,0,0.33,0.06,0.06)
		aa = false
	elseif (tp==2) and ba then
		sh.shGUI.addButton("Choose House Interior",sh.choice_inactive_button,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Basic House 220K",sh.customconfirm,13,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Crastenburg Luxury Suite 250K",sh.customconfirm,14,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Small House 320K",sh.customconfirm,4,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Lesters house 340K",sh.customconfirm,5,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Sinner Street 450K",sh.customconfirm,6,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Go back",sh.choice_type_of_custom,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Cancel",sh.choice_cancel,nil,0,0.33,0.06,0.06)
		ba = false
	elseif (tp==3) and ca then
		sh.shGUI.addButton("Choose House Interior",sh.choice_inactive_button,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Small Trailer USD 15K",sh.customconfirm,10,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Large Trailer USD 35K",sh.customconfirm,11,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Hotel room USD 50K",sh.customconfirm,1,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Movie makers office 100K",sh.customconfirm,2,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Basic Apartment 250K",sh.customconfirm,3,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Go back",sh.choice_type_of_custom,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Cancel",sh.choice_cancel,nil,0,0.33,0.06,0.06)
		ca = false
	end
	cba = false
	end
end

local aaa = true
local hprice = 0
local curcusprice = 0
function sh.customconfirm(tp)

	aaa = true
	local choosenint = {}
	hprice = 0

	for i,itp in ipairs(interior) do
		local b = 1
		while (b<=#interior) do
			local tbl = interior[b]
			if (tp==tonumber(tbl[1])) then choosenint = tbl end
			b = b+1
		end
	end

	local cprice = tonumber(choosenint[10])
	sh.clearbuttons()

	if aaa then
		if (not sh.domoneycheck(cprice)) then
		sh.shGUI.addButton("Price is USD "..cprice.."",sh.choice_inactive_button,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Not enough money",sh.choice_inactive_button,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Cancel",sh.choice_cancel,nil,0,0.33,0.06,0.06)
		aaa=false
		elseif (sh.domoneycheck(cprice)) then
		hprice = cprice
		curcusprice = hprice
		sh.shGUI.addButton("Price is USD "..cprice.."",sh.choice_inactive_button,nil,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Confirm",sh.customcreated,tp,0,0.33,0.06,0.06)
		sh.shGUI.addButton("Cancel",sh.choice_cancel,nil,0,0.33,0.06,0.06)
		aaa=false
		end
	end
end

function sh.customcreated(tp)

	print("creating custom house")

	local chtocreate = {}
	local coord = ENTITY.GET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(), true)
	local heading = ENTITY.GET_ENTITY_HEADING(PLAYER.PLAYER_PED_ID())
	local num = #ctable + 1
	local owner = (currentmodel + 1)

	table.insert(chtocreate, 1, num)
	table.insert(chtocreate, 2, "0")
	table.insert(chtocreate, 3, "0")
	table.insert(chtocreate, 4, "0")
	table.insert(chtocreate, 5, "0")
	table.insert(chtocreate, 6, "0")
	table.insert(chtocreate, 7, "0")
	table.insert(chtocreate, 8, coord.x)
	table.insert(chtocreate, 9, coord.y)
	table.insert(chtocreate, 10, coord.z)
	table.insert(chtocreate, 11, heading)
	table.insert(chtocreate, 12, currentmodel)
	table.insert(chtocreate, 13, "1")
	table.insert(chtocreate, 14, tp)
	table.insert(chtocreate, 15, curcusprice)
		if is_savespot then table.insert(chtocreate, 15, 500000) end
	table.insert(chtocreate, 16, 0)
		if is_savespot then table.insert(chtocreate, 16, 1) end
	table.remove(chtocreate, owner)
	table.insert(chtocreate, owner, "1")
	print("chtocreate table created")

	table.insert(ctable, num, chtocreate)
	sh.writetofile()

	local mod = (currentmodel - 1)
	local statname = "SP"..mod.."_TOTAL_CASH"
	local hash = GAMEPLAY.GET_HASH_KEY(statname)
	local bool, cash = STATS.STAT_GET_INT(hash, 0, -1)
	STATS.STAT_SET_INT(hash, (cash - hprice), true)

	sh.showhint(150,"Custom safehouse created")
		sh.blip_remove()
		sh.blip_add()
	
	is_savespot = false
	stopproxtick = false

	print("house created")

end

function sh.customsh()

	print("custom safehouse")

	stopproxtick = true
	print("tick stopped")
	local counter = (currentmodel + 1)
	curcusprice = tonumber(ctosave[15])
	typetoenter = 3

	if ((tonumber(ctosave[counter])==1) and (tonumber(ctosave[16])~=1)) then
		print("is custom house")

			sh.clearbuttons()
			sh.shGUI.addButton("Go Inside",sh.interior,nil,0,0.33,0.06,0.06)
			sh.shGUI.addButton("Sell for USD "..curcusprice,sh.choice_confirm_custom_remove,nil,0,0.33,0.06,0.06)
			sh.shGUI.addButton("Cancel",sh.choice_cancel,nil,0,0.33,0.06,0.06)
			
	elseif ((tonumber(ctosave[counter])==1) and (tonumber(ctosave[16])==1)) then
		print("is a save spot")
		
			sh.clearbuttons()
			sh.shGUI.addButton("Save Game",sh.savegame,typetoenter,0,0.33,0.06,0.06)
			sh.shGUI.addButton("Sell for USD "..curcusprice,sh.choice_confirm_custom_remove,nil,0,0.33,0.06,0.06)
			sh.shGUI.addButton("Cancel",sh.choice_cancel,nil,0,0.33,0.06,0.06)
			
	end

	print("end custom safehouse")
end

function sh.choice_confirm_custom_remove()

	sh.clearbuttons()
	sh.shGUI.addButton("Are you sure",sh.choice_inactive_button,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Yes",sh.cremove,nil,0,0.33,0.06,0.06)
	sh.shGUI.addButton("Cancel",sh.choice_cancel,nil,0,0.33,0.06,0.06)

end

function sh.cremove()

	print("remove csh")
	local num = tonumber(ctosave[1])

	table.remove(ctosave, 13)
	table.insert(ctosave, 13, "0")
	table.remove(ctable, num)
	table.insert(ctable, num, ctosave)
	sh.writetofile()
		sh.blip_remove()
		sh.blip_add()
	print("csh removed")

	local mod = (currentmodel - 1)
	local statname = "SP"..mod.."_TOTAL_CASH"
	local hash = GAMEPLAY.GET_HASH_KEY(statname)
	local bool, cash = STATS.STAT_GET_INT(hash, 0, -1)
	STATS.STAT_SET_INT(hash, (cash + curcusprice), true)
	sh.showhint(200,"Custom Savehouse sold for $"..curcusprice)

	sh.choice_cancel()

end

function sh.writetofile()
	print("writetofile")

	if enablehouse then
	local file = io.open(savepath .. "savehouses", "w")
	io.output(file)
	for a, v in ipairs(htable) do
		local vdata = sh.tostring(v)
		io.write(vdata .. "\n")
		--print("Writing to file savehouses line "..a)

	end
	io.close(file)
	end

	if enablehotels then
		local sfile = io.open(savepath .. "hotels", "w")
		io.output(sfile)
		for a, v in ipairs(httable) do
		local vdata = sh.tostring(v)
		io.write(vdata .. "\n")
		--print("Writing to file hotels line "..a)

	end
	io.close(sfile)
	end

	if enablecustom then
		local nfile = io.open(savepath .. "custom", "w")
		io.output(nfile)
		for a, v in ipairs(ctable) do
		local vdata = sh.tostring(v)
		io.write(vdata .. "\n")
		--print("Writing to file custom line "..a)

	end
	io.close(nfile)
	end

	sh.loadfiles()
	print("writetofile done")
end

function sh.domoneycheck(sum)

		local summa = tonumber(sum)
		local mod = (sh.whoisplayer() - 1)
		local statname = "SP"..mod.."_TOTAL_CASH"
		local hash = GAMEPLAY.GET_HASH_KEY(statname)
		local bool, cash = STATS.STAT_GET_INT(hash, 0, -1)
		print("Player Money: "..cash..", sum needed: "..summa)
		if (cash >= summa) then return true else return false end
		print("Money check finished, returning")
end

function sh.filecheck()

	if sh.checkdir() then print("checkdir is not nil")
		local f1 = io.open(savepath .. "savehouses", "r")
		if f1==nil then sh.filemakehouse() else io.close(f1) end
		local f2 = io.open(savepath .. "hotels", "r")
		if f2==nil then sh.filemakehotel() else io.close(f2) end
		local f3 = io.open(savepath .. "custom", "r")
		if f3==nil then sh.filemakecustom() else io.close(f3) end
		local f4 = io.open(savepath .. "modswitch", "r")
		if f4==nil then print("no modstatus file, making one")
			local file = io.open(savepath .. "modswitch", "w")
			if file==nil then return false
			else io.output(file) io.write("on" .. "\n") io.close(file) return true end
		else io.close(f4) end
	else
		allowmod = false
		dirok = false
		sh.showhint(1000,".../scripts/addins/savehousefolder cannot be accessed.".."\n".."Make sure you have that folder and restart.".."\n".."Safehouse Mod OFF")
	end
end

function sh.checkdir()
print("checkdir")
	local file = io.open(savepath .. "dircheck", "w")
	if file==nil then return false
	else io.output(file) io.write("on" .. "\n") io.close(file) return true end
print("checkdir end")
end

function sh.timelapse()

	local lhour = TIME.GET_CLOCK_HOURS()
	local currentday = TIME.GET_CLOCK_DAY_OF_MONTH()
	local lminute = TIME.GET_CLOCK_MINUTES()
	local lsec = 0
	local dur = (sleeptimer*60)

	local timetick = 1
	while (timetick<dur) do
		if (lhour>=24) then lhour=1
			TIME.SET_CLOCK_DATE(currentday+1,TIME.GET_CLOCK_MONTH(),TIME.GET_CLOCK_YEAR())
		end
		if (lminute>=60) then lhour=lhour+1 lminute=1 end
		lminute = lminute+1
		timetick = timetick+1
		TIME.SET_CLOCK_TIME(lhour, lminute, lsec)
		sh.showhint(10,""..lhour..":"..lminute)
		wait(10)
	end

end

function sh.camera_outside()

	local coords = ENTITY.GET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(), nil)
	local vals = {coords.x, coords.y, coords.z}

	CAM.DO_SCREEN_FADE_OUT(250)
	wait(500)

	if (typetoenter==1) then
		ENTITY.SET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(),tonumber(htosave[15]),tonumber(htosave[16]),tonumber(htosave[17]),true,true,true,true)
		ENTITY.SET_ENTITY_HEADING(PLAYER.PLAYER_PED_ID(),tonumber(htosave[18]))
		CAM.SET_GAMEPLAY_CAM_RELATIVE_HEADING(tonumber(htosave[18]))
	elseif (typetoenter==2) then
		ENTITY.SET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(),tonumber(httosave[20]),tonumber(httosave[21]),tonumber(httosave[22]),true,true,true,true)
		ENTITY.SET_ENTITY_HEADING(PLAYER.PLAYER_PED_ID(),tonumber(httosave[23]))
		CAM.SET_GAMEPLAY_CAM_RELATIVE_HEADING(tonumber(httosave[23]))
	end

	ENTITY.FREEZE_ENTITY_POSITION(PLAYER.PLAYER_PED_ID(),true)
	CAM.SET_FOLLOW_PED_CAM_VIEW_MODE(4)
	ENTITY.SET_ENTITY_VISIBLE(PLAYER.PLAYER_PED_ID(),false)
	ENTITY.SET_ENTITY_MAX_SPEED(PLAYER.PLAYER_PED_ID(),0)
	wait(250)
	wait (waittime) CAM.DO_SCREEN_FADE_IN(450)
	sh.timelapse()
	CAM.DO_SCREEN_FADE_OUT(250)
	wait(500)
	ENTITY.SET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(),tonumber(vals[1]),tonumber(vals[2]),tonumber(vals[3]),true,true,true,true)
	GAMEPLAY.CLEAR_AREA_OF_PEDS(tonumber(vals[1]),tonumber(vals[2]),tonumber(vals[3]), 15, true) --Testing needed
	ENTITY.FREEZE_ENTITY_POSITION(PLAYER.PLAYER_PED_ID(),false)
	ENTITY.SET_ENTITY_VISIBLE(PLAYER.PLAYER_PED_ID(),true)
	CAM.SET_FOLLOW_PED_CAM_VIEW_MODE(1)-------------------------------add remember prev state mech
	ENTITY.SET_ENTITY_MAX_SPEED(PLAYER.PLAYER_PED_ID(),15000)
	wait(250)
	wait (waittime) CAM.DO_SCREEN_FADE_IN(450)

end

function sh.filemakehouse()

	print("making house")

	local mkhtable = {}
	local i = 1
	while (i <= #h) do
		table.insert(mkhtable, h[i])
		i = i + 1
	end
	print("mkhtable"..#mkhtable)
	local file = io.open(savepath .. "savehouses", "w")
	io.output(file)
	for a, v in ipairs(mkhtable) do
		local vdata = sh.tostring(v)
		io.write(vdata .. "\n")
	end
	print("file created - h")
	io.close(file)

end

function sh.updateh()
	print("updating house")
	--print("htable: "..#htable)
	local updtable = {}
	local rowtable = {}
	if (#h>0) then
		local counter =  1
		while (counter <= #h) do
			rowtable = {}
			local rowhtable =  htable[counter]
				if (rowhtable==nil) then rowhtable={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0} end
			local hrow = h[counter]
				table.insert(rowtable, hrow[1])
				table.insert(rowtable, rowhtable[2])
				table.insert(rowtable, rowhtable[3])
				table.insert(rowtable, rowhtable[4])
				table.insert(rowtable, rowhtable[5])
				table.insert(rowtable, rowhtable[6])
				table.insert(rowtable, rowhtable[7])
				table.insert(rowtable, hrow[8])
				table.insert(rowtable, hrow[9])
				table.insert(rowtable, hrow[10])
				table.insert(rowtable, hrow[11])
				table.insert(rowtable, hrow[12])
				table.insert(rowtable, rowhtable[13])
				table.insert(rowtable, hrow[14])
				table.insert(rowtable, hrow[15])
				table.insert(rowtable, hrow[16])
				table.insert(rowtable, hrow[17])
				table.insert(rowtable, hrow[18])
			table.remove(htable, counter)
			table.insert(htable, counter, rowtable)
			--print("doing while, current line="..counter)
			counter = counter + 1
		end
		--print("while done, htable entries: "..#htable)
	end
	hupdated = true
	sh.writetofile()
	print("updating house done")
end

function sh.updateht()
	print("updating hotel")
	--print("httable: "..#httable)
	local updtable = {}
	local rowtable = {}
	if (#ht>0) then
		local counter =  1
		while (counter <= #ht) do
			rowtable = {}
			local rowhtable =  httable[counter]
				if (rowhtable==nil) then rowhtable={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0} end
			local hrow = ht[counter]
				table.insert(rowtable, hrow[1])
				table.insert(rowtable, rowhtable[2])
				table.insert(rowtable, rowhtable[3])
				table.insert(rowtable, rowhtable[4])
				table.insert(rowtable, rowhtable[5])
				table.insert(rowtable, rowhtable[6])
				table.insert(rowtable, rowhtable[7])
				table.insert(rowtable, rowhtable[8])
				table.insert(rowtable, rowhtable[9])
				table.insert(rowtable, rowhtable[10])
				table.insert(rowtable, rowhtable[11])
				table.insert(rowtable, rowhtable[12])
				table.insert(rowtable, rowhtable[13])
				table.insert(rowtable, hrow[14])
				table.insert(rowtable, hrow[15])
				table.insert(rowtable, hrow[16])
				table.insert(rowtable, hrow[17])
				table.insert(rowtable, hrow[18])
				table.insert(rowtable, hrow[19])
				table.insert(rowtable, hrow[20])
				table.insert(rowtable, hrow[21])
				table.insert(rowtable, hrow[22])
				table.insert(rowtable, hrow[23])
				table.insert(rowtable, hrow[24])
			table.remove(httable, counter)
			table.insert(httable, counter, rowtable)
			--print("doing while, current line="..counter)
			counter = counter + 1
		end
		--print("while done, ht_table entries: "..#httable)
	end
	htupdated = true
	sh.writetofile()
	print("updating hotel done")
end

function sh.filemakehotel()

	local mkhottable = {}
	local i = 1
	while (i <= #ht) do
		table.insert(mkhottable, ht[i])
		i = i + 1
	end
	print("mkhottable"..#mkhottable)
	local file = io.open(savepath .. "hotels", "w")
	io.output(file)
	for a, v in ipairs(mkhottable) do
		local vdata = sh.tostring(v)
		io.write(vdata .. "\n")
	end
	print("file created - hot")
	io.close(file)

end

function sh.filemakecustom()

	local c = {{1, 1,0,0, 0,0,0,-1066.7385253906,-1152.8004150391,2.3458766937256,24.428289413452,1,0},
	}
	local mkctable = {}
	local i = 1
	while (i <= #c) do
		table.insert(mkctable, c[i])
		i = i + 1
	end
	print("mkctable"..#mkctable)
	local file = io.open(savepath .. "custom", "w")
	io.output(file)
	for a, v in ipairs(mkctable) do
		local vdata = sh.tostring(v)
		io.write(vdata .. "\n")
	end
	print("file created - cus")
	io.close(file)

end

local dirch = {}
function sh.loadfiles()
	print("loadfiles")
	htable = {}
	httable = {}
	ctable = {}
	dirch = {}

	if enablehouse then
		for line in io.open(savepath .. "savehouses", "r"):lines() do
		sh.getarrayh(line)
		end
	end

	if enablehotels then
		for line in io.open(savepath .. "hotels", "r"):lines() do
		sh.getarrayht(line)
		end
	end

	if enablecustom then
		for line in io.open(savepath .. "custom", "r"):lines() do
		sh.getarrayc(line)
		end
	end

	if updatehouses and (not hupdated) then sh.updateh() end
	if updatehotels and (not htupdated) then sh.updateht() end

	print("files loaded")

end

function sh.getarrayh(str)
	local vals = {}
	for val in string.gmatch(str, '[^,]+') do
		table.insert(vals, val)
	end
	table.insert(htable, vals)
	--print("entries in htable:"..#htable)
end

function sh.getarrayht(str)
	local vals = {}
	for val in string.gmatch(str, '[^,]+') do
		table.insert(vals, val)
	end
	table.insert(httable, vals)
	--print("entries in httable:"..#httable)
end

function sh.getarrayc(str)
	local vals = {}
	for val in string.gmatch(str, '[^,]+') do
		table.insert(vals, val)
	end
	table.insert(ctable, vals)
	--print("entries in ctable:"..#ctable)
end

function sh.val_to_str (v)
  if "string" == type( v ) then
    v = string.gsub( v, "\n", "\\n" )
    if string.match( string.gsub(v,"[^'\"]",""), '^"+$' ) then
      return "'" .. v .. "'"
    end
    return '' .. string.gsub(v,'"', '\\"' ) .. ''
  else
    return "table" == type( v ) and sh.tostring( v ) or
      tostring( v )
  end
end

function sh.key_to_str (k)
  if "string" == type( k ) and string.match( k, "^[_%a][_%a%d]*$" ) then
    return k
  else
    return "[" .. sh.val_to_str( k ) .. "]"
  end
end

function sh.tostring (tbl)
  local result, done = {}, {}
  for k, v in ipairs( tbl ) do
    table.insert( result, sh.val_to_str( v ) )
    done[ k ] = true
  end
  for k, v in pairs( tbl ) do
    if not done[ k ] then
      table.insert( result,
        sh.key_to_str( k ) .. "=" .. sh.val_to_str( v ) )
    end
  end
  return table.concat( result, "," )
end

function sh.whoisplayer()

	local model = 0
	if (PED.IS_PED_MODEL(PLAYER.PLAYER_PED_ID(), GAMEPLAY.GET_HASH_KEY("player_zero"))) then model = 1 charactername = "Michael"
	elseif (PED.IS_PED_MODEL(PLAYER.PLAYER_PED_ID(), GAMEPLAY.GET_HASH_KEY("player_one"))) then model = 2 charactername = "Franklin"
	elseif (PED.IS_PED_MODEL(PLAYER.PLAYER_PED_ID(), GAMEPLAY.GET_HASH_KEY("player_two"))) then model = 3 charactername = "Trevor"
	end
	return model

end

function sh.checkspawn()

	print("checking spawn")
	local counter = (currentmodel + 4)

	if enablehouse then
		local i = 1
		while (i <= #htable) do
			local vdata = htable[i]
			if (tonumber(vdata[counter])==1) then
				htosave = htable[i]
				print("house set to "..i)
				sh.loading_screen(1, htable[i])
				break
			elseif tonumber(vdata[counter])==0 then
				i = i + 1
			end
		end
	end
	
	if enablehotels then
		local i = 2
		while (i <= #httable) do
			local vdata = httable[i]
			if (tonumber(vdata[counter])==1) then
				httosave = httable[i]
				print("hotel set to "..i)
				sh.loading_screen(2, httable[i])
				break
			elseif tonumber(vdata[counter])==0 then
				i = i + 1
			end
		end
	end


	if enablecustom then
		local i = 1
		while (i <= #ctable) do
			local vdata = ctable[i]
			if (tonumber(vdata[counter])==1) then
				if (tonumber(vdata[16])~=1) then
					ctosave = ctable[i]
					print("custom set to "..i)
					sh.loading_screen(1, ctable[i])
					break
				elseif (tonumber(vdata[16])==1) then
					sh.loading_screen(3, ctable[i])
					break
				end
			elseif tonumber(vdata[counter])==0 then
				i = i + 1
			end
		end
	end
	
	if (htosave == nil) and (httosave == nil) and (ctosave == nil) then loading_limbo = false print("no spaw points found") end
	
	print("checkspawn finished")

end

local sp_type = 0
local sparray = {}
function sh.loading_screen(sptype, array)
	
	print("loading screen")
	sp_type = sptype
	sparray = array	
	ENTITY.SET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(),405.936,-954.091,-98.004,true,true,true,true)
	loading_limbo = true
	sh.showhint(800,"Press E or Controller A when Map Editor has finished loading")
	print("loading screen finished")
end

function sh.spawnplayer()

	print("spawnplayer")
	CAM.DO_SCREEN_FADE_OUT(250)
	wait(500)
	if (sp_type == 1) then print("house or custom")
		if (ctosave~=nil) then --check if custom table is active. If it is, set house type to custom.
			typetoenter = 3
			isinside = true
			intarray = interior[tonumber(sparray[14])]
			cur_inside_interior = tonumber(intarray[1])
			ENTITY.SET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(),tonumber(intarray[6]), tonumber(intarray[7]), tonumber(intarray[8]),true,true,true,true)
		else
			typetoenter = 1
			isinside = true
			intarray = interior[tonumber(sparray[14])]
			cur_inside_interior = tonumber(intarray[1])
			ENTITY.SET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(),tonumber(intarray[6]), tonumber(intarray[7]), tonumber(intarray[8]),true,true,true,true)
		end
		TIME.SET_CLOCK_TIME(spawnhour, spawnminute, 0)
	elseif (sp_type == 2) then print("hotel")
		typetoenter = 2
		isinside = true
		intarray = interior[tonumber(sparray[19])]
		cur_inside_interior = tonumber(intarray[1])
		ENTITY.SET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(),tonumber(intarray[6]), tonumber(intarray[7]), tonumber(intarray[8]),true,true,true,true)
		TIME.SET_CLOCK_TIME(spawnhour, spawnminute, 0)
	elseif (sp_type == 3) then print("save spot")
		isinside = false
		ENTITY.SET_ENTITY_COORDS(PLAYER.PLAYER_PED_ID(),tonumber(sparray[8]), tonumber(sparray[9]), tonumber(sparray[10]),true,true,true,true)
		ENTITY.SET_ENTITY_HEADING(PLAYER.PLAYER_PED_ID(),tonumber(sparray[11]))
		TIME.SET_CLOCK_TIME(spawnhour, spawnminute, 0)
	end
	
	local mp_interior = INTERIOR.GET_INTERIOR_AT_COORDS(tonumber(intarray[2]), tonumber(intarray[3]), tonumber(intarray[4]))
	print("interior set to: "..mp_interior)
	INTERIOR._0x2CA429C029CCF247(mp_interior)
	if boolean_for_interior then STREAMING.SET_INTERIOR_ACTIVE (mp_interior, true)
	else STREAMING.SET_INTERIOR_ACTIVE (mp_interior, 1) end
	--STREAMING.SET_INTERIOR_ACTIVE (mp_interior, 1)
	INTERIOR.DISABLE_INTERIOR (mp_interior, false)
	table.insert(interiors_loaded, mp_interior)
	
	sh.blip_add_for_interior()
	tickcooldown = 200
	wait(500)
	wait (waittime) CAM.DO_SCREEN_FADE_IN(450)
	print("spawnplayer end")
end

function sh.showhint(tmr, text)
	timer = tmr
	hinttoshow = text
end

function sh.drawhint()
		UI.SET_TEXT_FONT(4)
		UI.SET_TEXT_SCALE(0.0, 0.6)
		UI.SET_TEXT_COLOUR(255, 255, 255, 255)
		UI.SET_TEXT_WRAP(0 , 2)
		UI.SET_TEXT_CENTRE(true)
		UI.SET_TEXT_DROPSHADOW(255, 255, 255, 255, 100)
		UI.SET_TEXT_EDGE(5, 0, 0, 0, 255)
		UI._SET_TEXT_ENTRY("STRING")
		UI._ADD_TEXT_COMPONENT_STRING(hinttoshow)
		UI._DRAW_TEXT(0.5, 0.3)
		timer = timer-1
end

local bliptable = {}

local blip = {}
local shblip = {}
local phblip = {}
local ohblip = {}
local ahtblip = {}
local ohtblip = {}
local cblip = {}
local forrent = {}
local rented = {}

function sh.blip_add()
	print("adding blips")

	bliptable = {}
	shblip = {}
	phblip = {}
	ohblip = {}
	ahtblip = {}
	ohtblip = {}
	cblip = {}
	forrent = {}
	rented = {}

	for i, coord in ipairs(realtors) do
			blip[i] = UI.ADD_BLIP_FOR_COORD(tonumber(coord[1]),tonumber(coord[2]),tonumber(coord[3]))
			UI.SET_BLIP_SPRITE(blip[i], 408)
			UI.SET_BLIP_SCALE(blip[i], blipsize)
			UI.SET_BLIP_AS_SHORT_RANGE(blip[i], true)
			--UI.SET_BLIP_NAME_FROM_TEXT_FILE(blip[i], "Real Estate Agency")
			table.insert(bliptable, (#bliptable+1), blip[i])
	end

	if enablehouse then
		local a = 1
		while (a <= #htable) do
			local tbl = htable[a]
			if (tonumber(tbl[13])==currentmodel) then
				table.insert(shblip, {tonumber(tbl[8]), tonumber(tbl[9]), tonumber(tbl[10])})
			elseif (tonumber(tbl[13])==0) then
				table.insert(phblip, {tonumber(tbl[8]), tonumber(tbl[9]), tonumber(tbl[10])})
			elseif (tonumber(tbl[13])~=0) and (tonumber(tbl[13])~=currentmodel) then
				table.insert(ohblip, {tonumber(tbl[8]), tonumber(tbl[9]), tonumber(tbl[10])})

			end
			a = a + 1
		end

		for i, coord in ipairs(shblip) do
			blip[i] = UI.ADD_BLIP_FOR_COORD(coord[1],coord[2],coord[3])
			UI.SET_BLIP_SPRITE(blip[i], 40)
			UI.SET_BLIP_SCALE(blip[i], blipsize)
			UI.SET_BLIP_AS_SHORT_RANGE(blip[i], true)
			table.insert(bliptable, (#bliptable+1), blip[i])
		end
	end

	if  enablehotels then print("adding blips for hotels")
		local b = 2
		while (b <= #httable) do
			local tbl = httable[b]
			local counter = (currentmodel + 1)
			if (tonumber(tbl[counter])==1) and (tonumber(tbl[24])==1) then
				table.insert(ahtblip, {tonumber(tbl[14]), tonumber(tbl[15]), tonumber(tbl[16])})
			elseif (tonumber(tbl[counter])==0) and (tonumber(tbl[24])==1) then
				table.insert(ohtblip, {tonumber(tbl[14]), tonumber(tbl[15]), tonumber(tbl[16])})
			end
			b = b + 1
		end

		for i, coord in ipairs(ahtblip) do
			local j = i + 1
			blip[i] = UI.ADD_BLIP_FOR_COORD(coord[1],coord[2],coord[3])
			UI.SET_BLIP_SPRITE(blip[i], 417)
			UI.SET_BLIP_SCALE(blip[i], blipsize)
			UI.SET_BLIP_AS_SHORT_RANGE(blip[i], true)
			blip[j] = UI.ADD_BLIP_FOR_COORD(coord[1],coord[2],coord[3])
			UI.SET_BLIP_SPRITE(blip[j], 431)
			UI.SET_BLIP_SCALE(blip[j], (blipsize - 0.1))
			UI.SET_BLIP_AS_SHORT_RANGE(blip[j], true)
			table.insert(bliptable, (#bliptable+1), blip[i])
			table.insert(bliptable, (#bliptable+1), blip[j])
		end

		for i, coord in ipairs(ohtblip) do
			blip[i] = UI.ADD_BLIP_FOR_COORD(coord[1],coord[2],coord[3])
			UI.SET_BLIP_SPRITE(blip[i], 417)
			UI.SET_BLIP_SCALE(blip[i], blipsize)
			UI.SET_BLIP_AS_SHORT_RANGE(blip[i], true)
			table.insert(bliptable, (#bliptable+1), blip[i])
		end

	--end

	--if enablehotels then
		local d = 2
		while (d <= #httable) do
			local tbl = httable[d]
			local counter = (currentmodel + 1)
			if (tonumber(tbl[counter])==1) and (tonumber(tbl[24])==2) then
				table.insert(rented, {tonumber(tbl[14]), tonumber(tbl[15]), tonumber(tbl[16])})
			elseif (tonumber(tbl[counter])==0) and (tonumber(tbl[24])==2) then
				table.insert(forrent, {tonumber(tbl[14]), tonumber(tbl[15]), tonumber(tbl[16])})
			end
			d = d + 1
		end

		for i, coord in ipairs(rented) do
			local j = i + 1
			blip[i] = UI.ADD_BLIP_FOR_COORD(coord[1],coord[2],coord[3])
			UI.SET_BLIP_SPRITE(blip[i], 411)
			UI.SET_BLIP_SCALE(blip[i], blipsize)
			UI.SET_BLIP_AS_SHORT_RANGE(blip[i], true)
			blip[j] = UI.ADD_BLIP_FOR_COORD(coord[1],coord[2],coord[3])
			UI.SET_BLIP_SPRITE(blip[j], 431)
			UI.SET_BLIP_SCALE(blip[j], (blipsize - 0.1))
			UI.SET_BLIP_AS_SHORT_RANGE(blip[j], true)
			table.insert(bliptable, (#bliptable+1), blip[i])
			table.insert(bliptable, (#bliptable+1), blip[j])
		end

		for i, coord in ipairs(forrent) do
			blip[i] = UI.ADD_BLIP_FOR_COORD(coord[1],coord[2],coord[3])
			UI.SET_BLIP_SPRITE(blip[i], 411)
			UI.SET_BLIP_SCALE(blip[i], blipsize)
			UI.SET_BLIP_AS_SHORT_RANGE(blip[i], true)
			table.insert(bliptable, (#bliptable+1), blip[i])
		end
	end

	if enablecustom then
		local c = 1
		while (c <= #ctable) do
			local tbl = ctable[c]
			if (tonumber(tbl[12])==currentmodel) and (tonumber(tbl[13])==1) then
				table.insert(cblip, {tonumber(tbl[8]), tonumber(tbl[9]), tonumber(tbl[10])})
			end
			c = c + 1
		end

		for i, coord in ipairs(cblip) do
			blip[i] = UI.ADD_BLIP_FOR_COORD(coord[1],coord[2],coord[3])
			UI.SET_BLIP_SPRITE(blip[i], 40)
			UI.SET_BLIP_SCALE(blip[i], blipsize)
			UI.SET_BLIP_AS_SHORT_RANGE(blip[i], true)
			table.insert(bliptable, (#bliptable+1), blip[i])
		end
	end

	print("shblip"..#shblip)
	print("phblip"..#phblip)
	print("ohblip"..#ohblip)
	print("ahtblip"..#ahtblip)
	print("ohtblip"..#ohtblip)
	print("forrent"..#forrent)
	print("rented"..#rented)
	print("cblip"..#cblip)
	print("bliptable "..#bliptable)

end

local realtorbliptable = {}
function sh.blip_remove()

	print("clearing blips")
	local i = 1
	while (i <= #bliptable) do
		UI.REMOVE_BLIP(bliptable[i])
		print("remove blip "..bliptable[i])
		i=i+1
	end
	local b=1
	while (b <= #realtorbliptable) do
		UI.REMOVE_BLIP(realtorbliptable[b])
		print("remove blip "..realtorbliptable[b])
		b=b+1
	end
	print("clearing inter blips")
	local c = 1
	while (c <= #interbliptable) do
		UI.REMOVE_BLIP(interbliptable[c])
		print("remove blip "..interbliptable[c])
		c=c+1
	end
	print("inter blips cleared")
	wait(500)
	print("blips cleared")

end

function sh.choice_cancel()
	sh.clearbuttons() sh.shGUI.hidden = true
	if isatrealtor then sh.rexit() end
	tickcooldown = 200
	dialogactive = false
end

function sh.choice_inactive_button()
	sh.shGUI.hidden = false sh.shGUI.selection = 0
end

return sh
